//+------------------------------------------------------------------+
//|   TRO_AUCTION_BARS                                               |
//|                                                                  |
//|   Copyright  2016, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//| DO NOT DISTRIBUTE THIS CODE BY ANY MEANS - tell people to        |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
#property description "TRO - TheRumpledOne" 
#property description "DO NOT POST THIS ON OTHER FORUMS" 
#property description "www.kreslik.com is where TRO indicators can be found" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 Turquoise   
#property indicator_color2 Navy         
#property indicator_color3 Gold      
#property indicator_color4 MediumVioletRed    
#property indicator_color5 Magenta   
  

extern bool TURN_OFF    = false ; 
  
extern int BarWidth = 1;
extern double myThreshold = 0.0 ; 

extern color BarColorUp   = Turquoise;
extern color BarColorDown = Magenta;
extern color BarColorHi   = Red;
extern color BarColorLo   = Blue;
extern color TextColor    = DimGray;

// extern int MaxBars=500;
extern int myWingdingUP = 218 ;// 112 110 119
extern int myWingdingDN = 217 ;// 112 110

double Gap = 1; // Gap between the lines of bars
//---- buffers

double buf1_up[];
double buf1_down[];
double buf1_H[];
double buf1_L[];

//---- variables

int    MAMode;
string strMAType;
double  xThreshold  , D1_High, D1_Low ,  price;

string tTrade = "" ;   
color tColor    = White;
string tObjName01   ;
int      corner;
int      window; 
string   shortName ;
int      win ;  


int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
      
   shortName  = "test" ;
   tObjName01 = shortName +  "0" ;

   IndicatorShortName(shortName);  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(0,myWingdingUP);
   SetIndexBuffer(0,buf1_up);

   
   SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(1,myWingdingDN);
   SetIndexBuffer(1,buf1_down);

/*   
   SetIndexStyle(2,DRAW_ARROW,0,BarWidth,BarColorHi);
   SetIndexArrow(2,myWingdingHL);
   SetIndexBuffer(2,buf1_H);
   
   SetIndexStyle(3,DRAW_ARROW,0,BarWidth,BarColorLo);
   SetIndexArrow(3,myWingdingHL);
   SetIndexBuffer(3,buf1_L);
*/
   
   deinit();

   xThreshold = myThreshold * point ;
   
   return(0);
   
}
 
//+------------------------------------------------------------------+
int deinit()
  {
   TRO();
   return(0);
  }
 
//+------------------------------------------------------------------+


int start()
{
   
   if( TURN_OFF ) {return(0) ; }   
     
   int    counted_bars=IndicatorCounted(); 
    if(counted_bars < 0) { return(0); }
//---- 
   int limit=Bars-counted_bars; 
   int i;
 
   int xacount = 0 ;
   int xbcount = 0 ;

   D1_High  =  iHigh(symbol,PERIOD_D1,0);   
   D1_Low   =  iLow(symbol,PERIOD_D1,0);
   
   for(i=0;i<limit;i++)
   { 

      buf1_up[i]     = EMPTY_VALUE;
      buf1_down[i]   = EMPTY_VALUE;
      buf1_H[i]      = EMPTY_VALUE;
      buf1_L[i]      = EMPTY_VALUE;
     
      if(xThreshold > 0.0)
      {
         if( (D1_High - Close[i]) > xThreshold && (Close[i] - D1_Low) > xThreshold )  { continue ; }
      }
         
      double O  = iOpen(NULL,0,i);              
      double C  = iClose(NULL,0,i);
      double H  = iHigh(NULL,0,i);
      double L  = iLow(NULL,0,i);

      double O1  = iOpen(NULL,0,i+1);              
      double C1  = iClose(NULL,0,i+1);
      double H1  = iHigh(NULL,0,i+1);
      double L1  = iLow(NULL,0,i+1);
     
      bool TYPE_A_DN = H > H1 && C < C1 ;
      bool TYPE_A_UP = L < L1 && C > C1 ;
      
      bool TYPE_C_DN = H > H1 && L < L1 && C < L1 ;
      bool TYPE_C_UP = H > H1 && L < L1 && C > H1 ;     
       
      if(TYPE_A_DN || TYPE_C_DN ) { buf1_down[i]   = H ; xacount = xacount + 1 ;}
      if(TYPE_A_UP || TYPE_C_UP ) { buf1_up[i]     = L ; xbcount = xbcount + 1 ;}     
                                                
   } // for 

   return(0);
}
 

//+------------------------------------------------------------------+

 
string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
} 
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
/*

   Comment(
    
   "myBreakOutPeriod = " , myBreakOutPeriod , "\n" , 
   "BObar = " , BObar , "\n" ,   
   "BOLEVELH " , DoubleToStr(BOLEVELH,Digits) , "\n" ,    
   "xacount = " , xacount , "\n" , 
   "BOLEVELL " , DoubleToStr(BOLEVELL,Digits) , "\n" ,       
    "xbcount = " , xbcount , "\n" ,   
  
   "myBars = " , myBars , "\n" , 
     
   "") ; 
   
http://lizardtrader.com/three-types-of-reversal-bars/   
   
The following 3 comparisons are all valid reversal down patterns (up reversals will be the opposite):

Type A, a bar with a higher high, and a close below the close of the previous bar
Type B, an outside bar with a close below the close of the previous bar
Type C, an outside bar with a close below the low of the previous bar
Outside bars have high and low points that eclipse the previous bar.  
   
*/  


