//+------------------------------------------------------------------+ 
//|   TRO_HL_STATS2                                                 | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be consideLL donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
 

#property indicator_chart_window

extern int myChartX   = 580 ;
extern int myChartY   = 0 ;
extern int myCorner   = 0 ;
extern string myFont  = "Courier" ;
extern int myFontSize = 12 ;
 
extern int myBars     = 240 ;
extern color colorHead  = Orange ;

double Hi, Li, C;

double prev_high, prev_low, prev_Low, D, p, value ;
int h  ;
string lbl[15], lbl2[15];
int n, j, i, shift, stop, nHH, nLL  ;

color pColor = Blue ;

string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 
double    H1L0, L1H0 ;

double point,  open, high, low, close, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange  ;  
double xMax = - 1,  xMin = 9999999999999, xDiff, xClose, xHigh, xLow, xRunUp, xRunDn, xPain ;
double High0, Low0, Open0,  Close0, Open1,High1, Low1, Close1   ;   
 
int     ind_bufferOp[], Stats[11], StatsLL[11], StatsHH[11],scountHH, scountLL;

 
bool LL0, LL1, HH0, HH1 ;
      
      
//+------------------------------------------------------------------+

int init()
{
   period       =  Period() ; 
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "HLStats"+symbol+period+myBars ;
   win          =  0 ;
   
   ArrayResize(ind_bufferOp,myBars) ;
   
   return(0);
}

  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}  
//+------------------------------------------------------------------+
int deinit()
{

   ObDeleteObjectsByPrefix(ShortName);   
   
   return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

   n       = 10;
    
   j       = 0 ;
   
   lbl[j]  = ShortName+j;
   lbl2[j] = tChartPeriod + " HL Stats(" + myBars+ ")" ;
   DoShow(j, colorHead);
   
   DoWork( period ) ;
   
   for( j = 1 ; j < 10 ; j++ )
   {
      lbl[j]  = ShortName+j;
      lbl2[j] = j+" in a row " ;
      DoShow(j, colorHead); 
   }

   return(0);
}

//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{

   ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
   ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
   ObjectSet(lbl[u],OBJPROP_XDISTANCE, myChartX);
   ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
   ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

   if(u > 0)
   {
   
      string glabel = lbl[u] + "HH" ;
      ObjectCreate(glabel,23,0,Time[0],PRICE_CLOSE);
      ObjectSet(glabel, OBJPROP_CORNER, myCorner );
      ObjectSet(glabel,OBJPROP_XDISTANCE, 100+myChartX);
      ObjectSet(glabel,OBJPROP_YDISTANCE,n+myChartY);
      ObjectSetText(glabel,""+StatsHH[u],myFontSize,myFont,Lime);
      
      string rlabel =  lbl[u] + "LL" ;
      ObjectCreate(rlabel,23,0,Time[0],PRICE_CLOSE);
      ObjectSet(rlabel, OBJPROP_CORNER, myCorner );
      ObjectSet(rlabel,OBJPROP_XDISTANCE, 130+myChartX);
      ObjectSet(rlabel,OBJPROP_YDISTANCE,n+myChartY);
      ObjectSetText(rlabel,""+StatsLL[u],myFontSize,myFont,Red);
      
   } 
   
   n = n+20;

   return(0);
  }

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{
   
   if(c1 > c2 ) { pColor = Lime ; } else {
   if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}  
  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, myFontSize, myFont , EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}

//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
void DoWork( int wPeriod )
{
   for(int i=myBars; i >= 0; i--) 
   {  
      ind_bufferOp[i] = 0 ;             
   } 
   
   for( i = 0 ; i <=11; i++ ) 
   { 
      Stats[i] = 0 ; 
      StatsLL[i] = 0 ; 
      StatsHH[i] = 0 ;
   }
     
   scountHH = 1 ;  
   scountLL = 1 ; 
        
   for( i=myBars; i > 0; i--)
   {
   
      High0   = iHigh(NULL,wPeriod,i) ;
      High1   = iHigh(NULL,wPeriod,i+1) ;
      Low0  = iLow(NULL,wPeriod,i) ;
      Low1  = iLow(NULL,wPeriod,i+1) ;

      if(High0 >= High1) { HH0 = true; } else { HH0 = false ; } 
      if(Low0  <= Low1)  { LL0 = true; } else { LL0 = false ; } 
     
      if( HH0 )  { scountHH = scountHH + 1 ; }
      if( LL0 )  { scountLL = scountLL + 1 ; }  
      if( !HH0 ) { StatsHH[scountHH] = StatsHH[scountHH] + 1 ; scountHH = 1 ; }    
      if( !LL0 ) { StatsLL[scountLL] = StatsLL[scountLL] + 1 ; scountLL = 1 ; }  
              
   } 


}

//+------------------------------------------------------------------+
/*

Comment(

"ind_bufferOp[0]" , ind_bufferOp[0] , "\n" ,   
"High0 " , DoubleToStr(High0,Digits) , "\n" ,  
"Low0 " , DoubleToStr(Low0,Digits) , "\n" ,   
"High1 " , DoubleToStr(High1,Digits) , "\n" ,  
"Low1 " , DoubleToStr(Low1,Digits) , "\n" ,   

"") ; 
*/