//+------------------------------------------------------------------+ 
//|   TRO_MFI                                                        | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_separate_window

 
#property indicator_buffers 3
 
extern bool   Show_Commemt   = true ;

//---- input parameters
extern int iMFIPeriod    = 14; 
extern int iNumBars      = 0 ;
extern int iMaxThreshold = 80 ;
extern int iMinThreshold = 20 ;

//---- buffers
double ExtMFIBuffer[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

double minpips = 99999, maxpips = -99999 , spread, diff, maxdiff=-999, mindiff=999;

string  sSpread, sOpen, sPrice, sHigh, sLow, sPct, sMinDateTime, sMaxDateTime ; 
int      cd, cd1, cd2, BarsBack1, BarsBack2, minbar, maxbar ;


string symbol, tChartPeriod,  tShortName, trademsg ;   
  
int    digits2, digits, period, win, xInc, yInc, xPos, yPos  ;  
 
double    point , maxpct, minpct ;
int MaxThresholdCount = 0 ;
int MinThresholdCount = 0, BarsInStudy ;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ; 
  
   string sShortName;
//----
   SetIndexBuffer(0,ExtMFIBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE, 0, 1, Blue );
//---- name for DataWindow and indicator subwindow label
   sShortName="MFI("+iMFIPeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,iMFIPeriod);
//----
   
   SetIndexBuffer( 1, ExtMapBuffer2 );
   SetIndexBuffer( 2, ExtMapBuffer3 );
 
   SetIndexStyle( 1, DRAW_LINE, 0, 1, Green );
   SetIndexStyle( 2, DRAW_LINE, 0, 1, Red );
 


   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,95 );
   SetLevelValue(2,90 );   
   SetLevelValue(3,80 );
   SetLevelValue(4,50);
   SetLevelValue(5,20 );
   SetLevelValue(6,10 );
   SetLevelValue(7,5 ); 
   return(0);
  }
 
//+------------------------------------------------------------------+ 
int deinit()
{  
   TRO() ;  
   
   return(0);
}   
//+------------------------------------------------------------------+
int start()
  {
   int    i,nCountedBars;
   
//---- insufficient data
   if(Bars<=iMFIPeriod) return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//----
   i=Bars-iMFIPeriod-1;
   if(nCountedBars>iMFIPeriod) 
      i=Bars-nCountedBars-1;
      

maxdiff = -9999 ;
mindiff = 99999 ;      

MaxThresholdCount = 0 ;
MinThresholdCount = 0 ;
      
     
      
   if( iNumBars > 0 ) { i = iNumBars ; }  
    
   BarsInStudy =  i ; 
      
   while(i>=0)
     {
      
         ExtMFIBuffer[i] = iMFI(symbol,period,iMFIPeriod,i);      
      
    diff = ExtMFIBuffer[i] ;  
      
    if( diff > maxdiff ) { maxdiff = diff ; maxbar = i ;}
    if( diff < mindiff && diff > 0) { mindiff = diff ; minbar = i ;}
    
    if( diff >= iMaxThreshold ) { MaxThresholdCount = MaxThresholdCount + 1 ;}
    if( diff <= iMinThreshold ) { MinThresholdCount = MinThresholdCount + 1 ;}
 

    ExtMapBuffer2[i] = maxdiff ;
    ExtMapBuffer3[i] = mindiff ;
      
      i--;
     }

   

if(Show_Commemt )
{

maxpct = (100.0 * MaxThresholdCount) / BarsInStudy ;

minpct = (100.0 * MinThresholdCount) / BarsInStudy ;

Comment("\n", 
 
"MFI(" + iMFIPeriod  + ")= ", DoubleToStr( diff , 2), "\n",    
"Bars In Study  = ", BarsInStudy  , "\n",  

"MAX MFI = ", DoubleToStr( maxdiff , 2),  "\n",   
"MAX BAR# = ", maxbar ,  " | " ,DoubleToStr( maxpct , 2),  "%\n",    
"MAX Threshold ",iMaxThreshold ," Exceeded ", MaxThresholdCount  ," times" ,  "\n",   
"MIN MFI = ", DoubleToStr( mindiff , 2), "\n",    
"MIN BAR# = ", minbar , " | " ,DoubleToStr( minpct , 2),  "%\n",    
"MIN Threshold ",iMinThreshold ," Exceeded ",  MinThresholdCount ," times" , "\n",    
"") ;    
   
}// if

   return(0);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
   