//+------------------------------------------------------------------+ 
//|   TRO_MID_LINES                                                  | 
//|                                                                  | 
//|   Copyright  2015, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2015, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 
#property strict 
#property indicator_chart_window
#property indicator_buffers 4 
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_color3 Aqua
#property indicator_color4 Magenta

extern bool   Show_Prev_Line  = true ; 
extern bool   Show_Cur_Line   = true ; 
extern bool   Show_Prev_Dot   = true ; 
extern bool   Show_Cur_Dot    = true ; 


extern int myPeriod  = 0 ;

extern int myStyle      = 0 ;
extern int myWidth      = 0 ; 
extern int myWingDing   = 119 ;  

extern color myColorCurrent   = Aqua ;
extern color myColorPrevious  = Magenta ;

//---- buffers 
double P0Buffer[], P1Buffer[], P2Buffer[], P3Buffer[] ;

string symbol, tChartPeriod, ShortName, tsymbol ;  

int     digits, period, win, digits2, n, j, i, w, BarShift ; 
 
double Ctl_Open, Ctl_Close, Ctl_High, Ctl_Low, Ctl_Diff, Ctl_Mid, Ctl_Pivot, Ctl_High1, Ctl_Low1, Ctl_Mid1;

double point ;   
                   
//+------------------------------------------------------------------+ 
int init() 
{ 
   period       =  Period() ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
 
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   if(myPeriod == 0) { myPeriod = period ; }

   if(Show_Cur_Line)
   {     
      SetIndexBuffer(0, P0Buffer);
      SetIndexStyle(0, DRAW_LINE, myStyle, myWidth, myColorCurrent );
   }
   
   if(Show_Prev_Line)
   { 
      SetIndexBuffer(1, P1Buffer);
      SetIndexStyle(1, DRAW_LINE, myStyle, myWidth, myColorPrevious ); 
   }   
      
   if(Show_Cur_Dot)
   {     
      SetIndexBuffer(2, P2Buffer);
      SetIndexArrow(2, myWingDing); 
      SetIndexStyle(2, DRAW_ARROW, myStyle, myWidth, myColorCurrent );
   }
   
   if(Show_Prev_Dot)
   { 
      SetIndexBuffer(3, P3Buffer);
      SetIndexArrow(3, myWingDing); 
      SetIndexStyle(3, DRAW_ARROW, myStyle, myWidth, myColorPrevious ); 
   }   
         
   deinit();
   
   return(0); 
} 
 //+------------------------------------------------------------------+ 
int deinit() 
{ 
   TRO(); 
   return(0); 
} 
 //+------------------------------------------------------------------+ 
int start() 
{ 
   
   int    counted_bars=IndicatorCounted(); 
   if(counted_bars < 0) return(-1); 

   int limit=MathMax(1,Bars-counted_bars-1); 

   for(int i=0;i<limit;i++)
   { 
         if(myPeriod != period) {BarShift  = iBarShift(symbol,myPeriod,Time[i],true); }
         else{ BarShift  = i ; }
      
         Ctl_High    = iHigh(symbol,myPeriod,BarShift) ;    // high of the Ctl period + 1
         Ctl_Low     = iLow(symbol,myPeriod,BarShift) ;     // low of the Ctl period + 1
    
         Ctl_Mid     = ( Ctl_High + Ctl_Low ) * 0.50 ;
       //  Ctl_Mid     = NormalizeDouble( Ctl_Mid , Digits ) ;
   
         Ctl_High1    = iHigh(symbol,myPeriod,BarShift+1) ;    // high of the Ctl period + 1
         Ctl_Low1     = iLow(symbol,myPeriod,BarShift+1) ;     // low of the Ctl period + 1
   
         Ctl_Mid1     = ( Ctl_High1 + Ctl_Low1 ) * 0.50 ;
        // Ctl_Mid1     = NormalizeDouble( Ctl_Mid1 , Digits ) ;
   
         P0Buffer[i] = Ctl_Mid;
         P1Buffer[i] = Ctl_Mid1 ;
         P2Buffer[i] = Ctl_Mid;
         P3Buffer[i] = Ctl_Mid1 ;

          
   } //end for 
   
   WindowRedraw();

   return(0); 
} 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
 
/*

 
 

 
*/

