 
// TRO_PRICE_ALERT_TIMED

#property indicator_chart_window
 
#property show_inputs
#define MaxAlerts 24

#include <stdlib.mqh>
#include <stderror.mqh>


extern string    Pair_1 = "EURUSD";
extern double    AlertPrice_1    = 0;
 
extern string    Pair_2 = "USDCHF";
extern double    AlertPrice_2    = 0;
 
extern string    Pair_3 = "GBPJPY";
extern double    AlertPrice_3    = 0;
 
extern string    Pair_4 = "USDJPY";
extern double    AlertPrice_4    = 0;
 
extern string    Pair_5 = "GBPUSD";
extern double    AlertPrice_5    = 0;
 

//extern int       Wait = 1;
   

//+------------------------------------------------------------------+
int    period, MODEDIGITS ;    
   
string symbol, tChartPeriod,  tShortName, tMessage ;  

double  MODEBID, MODEASK, MODEOPEN, MODECLOSE     ;

datetime Trigger ;

//+------------------------------------------------------------------+


int init()
{

   period = Period() ; 
   
   deinit();
   
   return(0);   
}
//+------------------------------------------------------------------+
int deinit()
{
 
   TRO();
   return(0);
}
//+------------------------------------------------------------------+   

//+------------------------------------------------------------------+

void DoWork( string RVsymbol , double RVvalue )
{
 
   if(RVvalue == 0.0) { return ; }  
    
   RefreshRates();  
    
   MODEDIGITS            = MarketInfo(RVsymbol,MODE_DIGITS) ;  
   MODEBID               = MarketInfo(RVsymbol,MODE_BID) ;    
   MODEASK               = MarketInfo(RVsymbol,MODE_ASK) ;  

   if ( Trigger != Time[0] ) 
   {
         
      if( MODEBID < RVvalue &&  MODEASK > RVvalue )
      {
           Trigger   = Time[0] ;
           tMessage  = "Price Alert " + DoubleToStr(RVvalue, MODEDIGITS)    ; 
           Alert( RVsymbol + " " + tMessage ); 
         
          
      }
   }
   return;
} 
 
//+------------------------------------------------------------------+
int start()
{
 
/* 
   while(true)
   {
*/     
      DoWork( Pair_1 , AlertPrice_1 );
      DoWork( Pair_2 , AlertPrice_2 );
      DoWork( Pair_3 , AlertPrice_3 );
      DoWork( Pair_4 , AlertPrice_4 );
      DoWork( Pair_5 , AlertPrice_5 );
/*            
      Sleep(Wait*1000);
   }
*/
   return(0);
}
 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0); 
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
 