//+------------------------------------------------------------------+ 
//|   TRO_TRAININGWHEELS_OPM_CPM                                     | 
//|                                                                  | 
//|   Copyright  2016, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1

//---- indicator parameters  
extern bool TURN_OFF    = false ;


input ENUM_TIMEFRAMES   EntryPeriod = 5 ; // EntryPeriod
input ENUM_TIMEFRAMES   ExitPeriod  = 1 ; // ExitPeriod

extern int corner         = 3;
extern int price_x_offset = 200 ; 
extern int price_y_offset = 30 ; 

extern string myFont          = "Terminal" ;
extern int   myFontSize       = 16;

extern string Sell_Message   = "SELL  - Open Below Prev Mid" ;
extern string Wait_Message   = "WAIT " ;
extern string Buy_Message    = "BUY - Open Above Prev Mid" ;
extern string Exit_Message   = "EXIT " ; 

extern color Buy_color     = Green;
extern color Wait_color    = DimGray;
extern color Sell_color    = Red;
 


int win            = 0;

string tMessage , xMessage ,oldmsg = "" ; 

string symbol, tChartPeriod,  xChartPeriod, tShortName ;  
int    digits, period  ; 
double point;

datetime Trigger ;

int OldBars = -1 , limit ;

color tColor = Yellow ;
 
color EntryColor, ExitColor ;

string tObjName03 = "TROTWprmid"  ; 

 
double  open1, high1, low1, close1, mid1, high2, low2, close2, mid2, open0, close0, high3, low3, close3, mid3 ;  
 
double  xopen1, xhigh1, xlow1, xclose1, xmid1, xhigh2, xlow2, xclose2, xmid2, xopen0, xclose0  ;  
  
  
//+------------------------------------------------------------------+ 
int init() 
{ 
 //  if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }         
   
   period       =  EntryPeriod ;
   tChartPeriod =  TimeFrameToString(period) ;
   xChartPeriod =  TimeFrameToString(ExitPeriod) ;
      
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
     
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   tShortName = "TRO_tw_OPM_CPM"+ symbol + tChartPeriod+xChartPeriod ;
   deinit() ;
   
   return(0); 
} 
//+------------------------------------------------------------------+ 

int deinit() 
{ 

   ObjectDelete("troopmcpm31");
   ObjectDelete("troopmcpm32"); 
   ObjectDelete(tObjName03);       
      
   TRO() ;
    
   return(0);   
}  
 
//+------------------------------------------------------------------+ 
int start() 
{ 
   if( TURN_OFF ) { deinit(); return(0) ; }
   
   EntryColor = Wait_color ;


   high2    = iHigh( symbol,EntryPeriod, 2) ;
   low2     = iLow( symbol,EntryPeriod, 2) ;
   close2   = iClose( symbol,EntryPeriod, 2) ;
   mid2     = 0.5 * ( high2 + low2 ) ;

   open1    = iOpen( symbol,EntryPeriod, 1) ;
   close1   = iClose( symbol,EntryPeriod, 1) ;
   high1    = iHigh( symbol,EntryPeriod, 1) ;
   low1     = iLow( symbol,EntryPeriod, 1) ;
   mid1     = 0.5 * ( high1 + low1 ) ;  
   
   open0    = iOpen( symbol,EntryPeriod, 0) ;
   close0   = iClose( symbol,EntryPeriod, 0) ;
  
   xhigh2    = iHigh( symbol,ExitPeriod, 2) ;
   xlow2     = iLow( symbol,ExitPeriod, 2) ;
   xclose2   = iClose( symbol,ExitPeriod, 2) ;
   xmid2     = 0.5 * ( xhigh2 + xlow2 ) ;

   xopen1    = iOpen( symbol,ExitPeriod, 1) ;
   xclose1   = iClose( symbol,ExitPeriod, 1) ;
   xhigh1    = iHigh( symbol,ExitPeriod, 1) ;
   xlow1     = iLow( symbol,ExitPeriod, 1) ;
   xmid1     = 0.5 * ( xhigh1 + xlow1 ) ;  

   while(true)
   {   

      if( open1 < mid2 && open0 > mid1 ) { tMessage = Buy_Message + " " + tChartPeriod  ;  EntryColor = Buy_color ; break ; } // && open0 > mid1

      if( open1 > mid2 && open0 < mid1 ) { tMessage = Sell_Message + " " + tChartPeriod ; EntryColor = Sell_color ; break ; } // && open0 < mid1 

      if( close0 < mid1 && close0 <= open0 ) { tMessage = Wait_Message + " SHORT " + tChartPeriod ; EntryColor = Sell_color ; break ; } //  

      if( close0 > mid1 && close0 >= open0 ) { tMessage = Wait_Message + " LONG "  + tChartPeriod ; EntryColor = Buy_color ; break ; } //  
         
      tMessage    = Wait_Message + " "  + tChartPeriod   ; 
      EntryColor  = Wait_color ; 
      
      break;
   
   } // while     

   while(true)
   {   

      if( close0 < xmid1 ) { xMessage = Exit_Message + " LONG " + xChartPeriod ; ExitColor = Sell_color  ; break ; } //  

      if( close0 > xmid1 ) { xMessage = Exit_Message + " SHORT " + xChartPeriod ; ExitColor = Buy_color ; break ; } //  
                
      xMessage    = "WAIT FOR EXIT " + xChartPeriod   ; 
      ExitColor   = Wait_color ; 
      
      break;
   
   } // while
 
   tMessage = fFill( tMessage, 30 ) ;
   xMessage = fFill( xMessage, 30 ) ;
     
/*


      if( close2 < mid2 && close1 > mid2  ) { tMessage = Buy_Message ;  EntryColor = Buy_color ; break ; } // && open0 > mid1

      if( close2 > mid2 && close1 < mid2 ) { tMessage = Sell_Message ; EntryColor = Sell_color ; break ; } // && open0 < mid1 
    
*/         


//+------------------------------------------------------------------+  
                    
   ObjectCreate("troopmcpm31", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("troopmcpm31",tMessage, myFontSize , myFont, EntryColor );
   ObjectSet("troopmcpm31", OBJPROP_CORNER, corner);
   ObjectSet("troopmcpm31", OBJPROP_XDISTANCE, price_x_offset); 
   ObjectSet("troopmcpm31", OBJPROP_YDISTANCE, price_y_offset); 

   ObjectCreate("troopmcpm32", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("troopmcpm32",xMessage, myFontSize , myFont, ExitColor );
   ObjectSet("troopmcpm32", OBJPROP_CORNER, corner);
   ObjectSet("troopmcpm32", OBJPROP_XDISTANCE, price_x_offset); 
   ObjectSet("troopmcpm32", OBJPROP_YDISTANCE, price_y_offset-myFontSize ); 
 
   WindowRedraw();   
   
   return(0);
}
 
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
 
/*
 
   high3    = iHigh( symbol,period, 3) ;
   low3     = iLow( symbol,period, 3) ;
   close3   = iClose( symbol,period, 3) ;
   mid3     = 0.5 * ( high3 + low3 ) ; 
 
if( C < D1_low  && open > D1_low  )
{
   Comment(
   "period  " , period, "\n" ,
   "D0_high:" +  DoubleToStr( D0_high , Digits) , "\n" ,
   "D0_low:" +  DoubleToStr( D0_low , Digits) , "\n" ,    
   "D1_high:" +  DoubleToStr( D1_high , Digits) , "\n" ,
   "D1_low:" +  DoubleToStr( D1_low , Digits) , "\n" ,
   "open:" +  DoubleToStr(open , Digits) , "\n" ,
   "high:" +  DoubleToStr( high , Digits) , "\n" ,
   "low:" +  DoubleToStr( low , Digits) , "\n" ,
      
   "C:" +  DoubleToStr( C , Digits) , "\n" ,
   "HO:" +  DoubleToStr( HO , Digits) , "\n" ,
   "LO:" +  DoubleToStr( LO , Digits) , "\n" ,
   "nHO  " , nHO, "\n" ,   
   "nLO  " , nLO, "\n" ,  
   
   "clHO:" +  DoubleToStr( clHO , Digits) , "\n" ,
   "clLO:" +     DoubleToStr( clLO , Digits) , "\n" ,
   "tMessage  " , tMessage, "\n" ,
   "limit " , limit, "\n" ,
   
   "") ;   
}
 
*/