//+------------------------------------------------------------------+ 
//|   TRO_WICKS_BODY_TAILS                                           | 
//|                                                                  | 
//|   Copyright  2016, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//| DO NOT DISTRIBUTE THIS CODE BY ANY MEANS - tell people to        |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 




#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3

//----
extern color color1 = Red;
extern color color2 = Red;
extern color color3 = Blue;
extern color color4 = Blue;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//----
int ExtCountedBars=0;

double TOP, BOTTOM, WICK, BODY, TAIL ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 3, color1);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 3, color2);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, color3);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, color4);
   SetIndexBuffer(3, ExtMapBuffer4);
//----
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
   {
   
      ExtMapBuffer1[pos] = EMPTY_VALUE;
      ExtMapBuffer2[pos] = EMPTY_VALUE;      
      ExtMapBuffer3[pos] = EMPTY_VALUE;
      ExtMapBuffer4[pos] = EMPTY_VALUE;  
               
      haOpen  = Open[pos];
      haClose = Close[pos];
      haHigh  = High[pos];
      haLow   = Low[pos];
      TOP     = MathMax(haClose,haOpen);
      BOTTOM  = MathMin(haClose,haOpen);
      
      WICK    = haHigh - TOP;
      BODY    = TOP - BOTTOM;
      TAIL    = BOTTOM - haLow;
 
      while(true)
      {      
         if( WICK > BODY && BODY > TAIL) 
         { 
            ExtMapBuffer1[pos] = haHigh;
            ExtMapBuffer2[pos] = TOP;
         }   
         
         if( WICK < BODY && BODY < TAIL) 
         {          
            ExtMapBuffer3[pos] = BOTTOM;
            ExtMapBuffer4[pos] = haLow;          
         }
   
         if( WICK > BODY + TAIL) 
         { 
            ExtMapBuffer1[pos] = haHigh;
            ExtMapBuffer2[pos] = TOP;
         }   
         
         if( WICK + BODY < TAIL) 
         {          
            ExtMapBuffer3[pos] = BOTTOM;
            ExtMapBuffer4[pos] = haLow;          
         }
   
         break;
   
      } // while


 	   pos--;
   } // while
 

   WindowRedraw();

   return(0);
  }
//+------------------------------------------------------------------+