//+------------------------------------------------------------------+ 
//|   TRO_YTD_LINES                                                 | 
//|                                                                  | 
//|   Copyright  2014, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2014, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window
 

extern int myChartX   = 1 ;
extern int myChartY   = 100 ;
extern int myCorner   = 1 ;
extern string myFont  = "Terminal" ;
extern int myFontSize = 10 ;

extern bool   Show_Stats  = true ;
extern bool   Show_Boxes  = true ;
extern bool   Show_Labels = true ;
extern int    ShiftLabel  =  10 ;

 
 
extern int  iThreshold       = 10; 
 
 

extern int    Line_Style_YR    = STYLE_SOLID ;
extern int    Line_Width_YR    = 1 ;

extern color  Color_Message        = Aqua ;
extern color  Color_Up             = Green ;
extern color  Color_Eq             = DimGray ; 
extern color  Color_Dn             = Red ; 

extern color  Line_Color_Open      = Orange ;  
extern color  Line_Color_Hi        = Red ;
extern color  Line_Color_Mid       = Aqua ;
extern color  Line_Color_Lo        = Blue ;

 


string lbl[99], lbl2[99];
int n, j, i ,a ;

string symbol, tChartPeriod, ShortName , TAG , text, MESSAGE;  

int    digits, period, win, THISMONTH, nHH, nLL , YEARBAR , BarShift ; 

double point ;

double    TRIGGER, HHtrigger, LLtrigger ;
datetime DateTime ; 
        
double  open, close,   high, low , ABOVEMID ,BELOWMID ; 

double  YR_Open, YR_High, YR_Low, YR_Close,YR_pivot,   YR_Close1, YR_High1, MNThreshold, YR_LoMN, YR_Mid ; 

color cLineColor ;

datetime TIMEBAR ;
 
//+------------------------------------------------------------------+ 

int init()
{
   period = Period() ; 

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "troYTDL" ;
   ShortName    =  TAG+symbol+period   ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   deinit();
 
   return(0);
  }
//+------------------------------------------------------------------+
void ObDeleteObjectsByPrefix(string Prefix)
  {
   int LL = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, LL) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  } 
  
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
 
//+------------------------------------------------------------------+
int start()
{

   n       = 10;
   j       = 0 ;
 
 
   DoYR() ;  
   
   WindowRedraw() ;
   
   return(0);
}

//+------------------------------------------------------------------+  
void DoYR()
{   
     
   THISMONTH = TimeMonth(Time[0]) ;
   DateTime  = iTime(symbol,PERIOD_MN1,THISMONTH - 1 );
   
   BarShift  = iBarShift(symbol,period,DateTime,false);    

   open = iOpen( symbol, PERIOD_MN1, THISMONTH - 1 )  ; 
   
   nHH   =  iHighest(symbol,PERIOD_MN1,MODE_HIGH,THISMONTH,0); 
   nLL   =  iLowest(symbol,PERIOD_MN1,MODE_LOW,THISMONTH,0); 
 
   high  = iHigh(symbol,PERIOD_MN1,nHH);  
   low   = iLow(symbol,PERIOD_MN1,nLL);           
 
   YR_Close = iClose(symbol,PERIOD_MN1,0); 

   YR_Mid   = (high + low) * 0.50 ; 

j       = j + 1 ;
lbl[j]  = ShortName+"YR"+j;
drawLine(open   ,lbl[j], Line_Color_Open , Line_Style_YR  , Line_Width_YR , DateTime, "Yearly Open"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+"YR"+j;
drawLine(high   ,lbl[j], Line_Color_Hi , Line_Style_YR  , Line_Width_YR , DateTime, "Yearly High"     ) ;
 
j       = j + 1 ;
lbl[j]  = ShortName+"YR"+j;
drawLine(low   ,lbl[j], Line_Color_Lo , Line_Style_YR  , Line_Width_YR , DateTime, "Yearly Low"     ) ;
     
j       = j + 1 ;
lbl[j]  = ShortName+"YR"+j;
drawLine(YR_Mid   ,lbl[j], Line_Color_Mid , Line_Style_YR  , Line_Width_YR , DateTime, "Yearly Mid"     ) ;
  
 
   ABOVEMID = 0.0 ;
   BELOWMID = 0.0 ;
   
   for(int x=0 ; x < BarShift ; x++ )
   {
      close = iClose(symbol,period,x) ;
      
      if( close > YR_Mid ) { ABOVEMID = ABOVEMID + 1 ; } else 
      if( close < YR_Mid ) { BELOWMID = BELOWMID + 1 ; }
   }   
 
   MESSAGE = "# BARS ABOVE MIDPOINT= " + ABOVEMID ;
   drawComment(TAG+1,MESSAGE , myChartX , myChartY , Color_Message   ) ; 
   
   MESSAGE = "# BARS BELOW MIDPOINT= " + BELOWMID ;
   drawComment(TAG+2,MESSAGE , myChartX , myChartY+20 , Color_Message   ) ; 

  
} 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string xtext)
{
    
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
     datetime LabelTime = Time[0]+Period()*60*ShiftLabel ; 
 
   if(Show_Labels)
   {         
      string Obj0002 = name+"linelbl" ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002, xtext , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl); // Time[ShiftLabel]
      } // if 
                 
   } // if   

   if(Show_Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}
//+------------------------------------------------------------------+
 
void drawComment(string tLabel,string name, int xPos, int yPos ,color Color  )
{

ObjectCreate(tLabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(tLabel, OBJPROP_CORNER, myCorner );
ObjectSet(tLabel,OBJPROP_XDISTANCE,xPos);
ObjectSet(tLabel,OBJPROP_YDISTANCE,yPos);
ObjectSetText(tLabel,name,myFontSize,myFont,Color); 
}
 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

j       = j + 1 ;
lbl[j]  = ShortName+"YR"+j;
drawLine(YR_Close   ,lbl[j], Line_Color_Close , Line_Style_YR  , Line_Width_YR , DateTime, "Yearly Close["+myShift+"]"   ) ;


Comment(

 "\n" , 
"DailyOpen " , DoubleToStr(D1_Open,Digits) , "\n" ,
"ATR " , DoubleToStr(D1_ATR,Digits) , "\n" , 
"\n" , 
"DailyOpen + ATR " , DoubleToStr(D1_Open + D1_ATR,Digits) , "\n" , 
"D1_high " , DoubleToStr(D1_high,Digits) , "\n" ,
"D1_low " , DoubleToStr(D1_low,Digits) , "\n" ,
"DailyOpen - ATR " , DoubleToStr(D1_Open - D1_ATR,Digits) , "\n" , 
"") ; 


 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 

//+------------------------------------------------------------------+
      
color fColor( double aa, double bb)
{
color rColor ;
 
    if ( aa > bb ) { rColor = Color_Up; } else {
    if ( aa < bb ) { rColor = Color_Dn;   } else {           
                     rColor = Color_Eq; } }
    
return ( rColor );
}
 
 
 */