//+------------------------------------------------------------------+ 
//|  _TRO_COMPASS_HIOP_MP                                            | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 

//---- indicator settings 
#property indicator_separate_window
#property indicator_buffers 0
//#property indicator_minimum 0
//#property indicator_maximum 1


//---- indicator parameters  
 

//extern int win = 1;
extern int price_x_offset= 0 ;//250
extern int price_y_offset= -160 ;//-160

//extern bool Show_arrow = true ;
//extern bool Show_value = true ;
//extern int  myDecimals = 2 ;

extern string myFont       = "Arial Bold" ; // Arial Bold "Swis721 BlkOul BT"
extern int    myFontSize   = 30 ;
//extern int    myArrowSize  = 40 ;
extern int    myDigitSize  = 20 ;
extern int    xStart       = -600 ;
extern int    xOffSet      = 100 ;



//extern int    myPrice    = 0 ;

extern color  myIndColor = DarkGray ;

/*
extern color N_color  = Green;
extern color NE_color = Green;
extern color E_color  = Goldenrod;
extern color SE_color = Red;
extern color S_color  = Red;
*/

//---- indicator buffers 



// int   Chart_Period    = PERIOD_H1;


//---- buffers





string Arrow12 = ""; // 12 oclock
string Arrow2  = "";  // 2 oclock
string Arrow3  = "";  // 3 oclock
string Arrow5  = "";  // 5 oclock
string Arrow6  = "";  // 6 oclock


string tObjName01   ;
string tObjName02   ;
string tObjName03   ;
string tObjName04 , tObjName05, IndHead ;


double pCount   ;

int   HighDir, LowDir, MidDir, Mid1Dir, CloseDir, ClOpDir ;
color HighColor, LowColor, hiopColor, oploColor, CloseColor ;

int PriceDir   ;

string tPeriod   ; 

double cVal, pVal ;

double open    ;  
double close    ; 
double close1   ;  
double high    ;    
double high1    ;   
double low     ;    
double low1     ; 
double high2;   
double low2; 
double high3;   
double low3;  
double high4;   
double low4; 
double high5;   
double low5; 
double high6;   
double low6; 
double rng;    
double rng1;    
double rng2;    
double rng3;  
double rng4;   
double rng5;  
double rng6; 
double mid      ; 
double mid1    ; 

double open1;    
double open2;    
double open3;  
double open4;   
double open5;  
double open6;

double hiop;  
double hiop1;    
double hiop2;    
double hiop3;  
double hiop4;   
double hiop5;  
double hiop6;

double oplo;  
double oplo1;    
double oplo2;    
double oplo3;  
double oplo4;   
double oplo5;  
double oplo6;

//+------------------------------------------------------------------+
int      totalLabels;
string   labelNames;
int      corner;
int      window; 
string   shortName ;
int      win ;
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

int init() 
  { 
   shortName  = MakeUniqueName("HiOp ","");
   labelNames = shortName;
   IndicatorShortName(shortName);
   totalLabels     = 0;



   return(0); 
  } 

int deinit() 
{ 
   while (totalLabels>0) { ObjectDelete(StringConcatenate(labelNames,totalLabels)); totalLabels--;}
  
DoDelObj( PERIOD_M1 ) ;
DoDelObj( PERIOD_M5 ) ;
DoDelObj( PERIOD_M15 ) ;  
DoDelObj( PERIOD_H1 ) ;
DoDelObj( PERIOD_H4 ) ;
DoDelObj( PERIOD_D1 ) ;
DoDelObj( PERIOD_W1 ) ;
DoDelObj( PERIOD_MN1 ) ;

return(0);  
}  

//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 


int xStart2 = xStart + xOffSet ;
int xStart3 = xStart + xOffSet*2 ;
int xStart4 = xStart + xOffSet*3 ;
int xStart5 = xStart + xOffSet*4 ;
int xStart6 = xStart + xOffSet*5 ;
int xStart7 = xStart + xOffSet*6 ;
int xStart8 = xStart + xOffSet*7 ;

win =    WindowFind(shortName);

bool sFirst = true ;

if ( sFirst ) {
sFirst = false ;
ObjectDelete(tObjName04);

ObjectsDeleteAll( win, 21);
ObjectsDeleteAll( win, 22);
ObjectsDeleteAll( win, 23);
}

IndHead =  "HiOp/OpLo"  ;

DoWork( PERIOD_M1 ) ;
DoShow( PERIOD_M1, xStart ) ;

DoWork( PERIOD_M5 ) ;
DoShow( PERIOD_M5, xStart2 ) ;

DoWork( PERIOD_M15 ) ;
DoShow( PERIOD_M15, xStart3 ) ;                      

DoWork( PERIOD_H1 ) ;
DoShow( PERIOD_H1, xStart4 ) ;

DoWork( PERIOD_H4 ) ;
DoShow( PERIOD_H4, xStart5 ) ;

DoWork( PERIOD_D1 ) ;
DoShow( PERIOD_D1, xStart6 ) ;

DoWork( PERIOD_W1 ) ;
DoShow( PERIOD_W1, xStart7 ) ;

DoWork( PERIOD_MN1 ) ;
DoShow( PERIOD_MN1, xStart8 ) ;

DoHead(IndHead );

WindowRedraw();    
 


   return(0); 
} 
 
 
//+------------------------------------------------------------------+ 

void DoWork( int myPeriod  )  
{

 
close  = iClose( NULL , myPeriod , 0 ) ; 

high   = iHigh( NULL , myPeriod , 0 ) ;    
 
low    = iLow( NULL , myPeriod , 0 ) ;    

open   = iOpen( NULL , myPeriod , 0 ) ;   

hiop   = ( high  - open ) ; 

oplo   = ( open  - low ) ; 

CloseColor = Goldenrod;

}

//+------------------------------------------------------------------+ 
void DoDelObj( int lPeriod  )  
{

tObjName01 = labelNames +lPeriod +  "CIN030" ;
tObjName02 = labelNames +lPeriod +  "CIN031" ;
tObjName03 = labelNames +lPeriod +  "CIN032" ;
//tObjName04 = labelNames +  "CIN000" ;
tObjName05 = labelNames +lPeriod +  "CIN035" ;

ObjectDelete(tObjName01);
ObjectDelete(tObjName02);
ObjectDelete(tObjName03);
ObjectDelete(tObjName04);
ObjectDelete(tObjName05);
}

//+------------------------------------------------------------------+ 
void DoShow( int lPeriod , int xInc)  
{

tObjName01 = labelNames +lPeriod +  "CIN030" ;
tObjName02 = labelNames +lPeriod +  "CIN031" ;
tObjName03 = labelNames +lPeriod +  "CIN032" ;
tObjName05 = labelNames +lPeriod +  "CIN035" ;


tPeriod  = TimeFrameToString( lPeriod ) ;

   ObjectCreate(tObjName01, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName01, tPeriod, myFontSize, myFont, CloseColor );
   ObjectSet(tObjName01, OBJPROP_CORNER, 0);
   ObjectSet(tObjName01, OBJPROP_XDISTANCE,  xInc+980+price_x_offset); // 760
   ObjectSet(tObjName01, OBJPROP_YDISTANCE, 175+price_y_offset); // 160

int sInc = 0 ;

/*
if(Show_arrow){

sInc = 50 ;
   
   ObjectCreate(tObjName03, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, PriceDir , myArrowSize , "Wingdings" , CloseColor );
   ObjectSet(tObjName03, OBJPROP_CORNER, 0);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, xInc+980+price_x_offset); // 765
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 210+price_y_offset); 
   
} //if(Show_arrow)
*/

//if(Show_value){

hiopColor = CloseColor ;
oploColor = CloseColor ;

if(close > open) {hiopColor = Green ; } else { oploColor = Red ;  }    

int tRng = hiop / Point ;
    
   ObjectCreate(tObjName02, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName02, tRng+"" ,myDigitSize, myFont , hiopColor );
   ObjectSet(tObjName02, OBJPROP_CORNER, 0);
   ObjectSet(tObjName02, OBJPROP_XDISTANCE, xInc+980+price_x_offset); // 765
   ObjectSet(tObjName02, OBJPROP_YDISTANCE, 230+price_y_offset); 

int tRng1 = oplo / Point ;
   
   ObjectCreate(tObjName05, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName05, tRng1+"" ,myDigitSize, myFont , oploColor );
   ObjectSet(tObjName05, OBJPROP_CORNER, 0);
   ObjectSet(tObjName05, OBJPROP_XDISTANCE, xInc+980+price_x_offset); // 765
   ObjectSet(tObjName05, OBJPROP_YDISTANCE, 260+price_y_offset); 
      
   
//} //if(Show_value)



}

//+------------------------------------------------------------------+ 

void DoHead( string dHead  )  
{

tObjName04 = labelNames +  "CIN000" ;

   ObjectCreate(tObjName04, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName04, dHead, myFontSize, myFont, myIndColor );
   ObjectSet(tObjName04, OBJPROP_CORNER, 0);
   ObjectSet(tObjName04, OBJPROP_XDISTANCE,  00+price_x_offset); // 760
   ObjectSet(tObjName04, OBJPROP_YDISTANCE, 210+price_y_offset); // 160
}

//+------------------------------------------------------------------+ 


// string next() { totalLabels++; return(totalLabels); }  

//+------------------------------------------------------------------+

 
string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

/*

val=High[iHighest(NULL,0,MODE_HIGH,20,4)];

Constant	Value	Description
MODE_OPEN	0	Open price_
MODE_LOW	   1	Low price_
MODE_HIGH	2	High price_
MODE_CLOSE	3	Close price_
MODE_VOLUME	4	Volume, used in iLowest() and iHighest() functions.
MODE_TIME	5	Bar open time, used in ArrayCopySeries() function.

*/