//+------------------------------------------------------------------+
//|   TRO_ATR_CW                                                     | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 
#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
           
#property indicator_chart_window
#property indicator_buffers 4

//#property indicator_color1 Violet
//#property indicator_color2 DodgerBlue

//---- input parameters

extern bool    Show_LABEL = true ;
extern bool    Show_COMMENT = true ;
extern string  ATR_COMMENT = "ATR DOTS PLOTTED ATR ABOVE/BELOW OPEN & HIGH/LOW" ;
extern int    ATR_CHART_Period = 1440;
extern int    ATR_Period = 14;
extern double ATR_MULT  = 1.0 ;
extern int    ATR_WIDTH = 0 ;
extern color  ATR_COLOR_OPEN = Violet ;
extern color  ATR_COLOR_HIGH = Aqua ;
extern color  ATR_COLOR_LOW  = Navy ;
extern int    ATR_WingDing  = 119 ; 

//---- buffers

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];

double xATR, ATR, xPCT, LOWPLUSATR, HIGHMINUSATR, PLUSATR, MINUSATR, upPCT, dnPCT, upHits, dnHits, passes ;  

double  high ,low, range, open, close ;

 
string short_name, TAG;
 
string symbol, tChartPeriod ; 
int    digits, period , j=0, iTF;   


string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  


//+------------------------------------------------------------------+
int init()
{
  
   period = Period() ;
   
      switch(ATR_CHART_Period)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }  
     
   short_name= TimeFrameStr + " ATR("+ATR_Period+") "; 
   
   TAG = "ATRcw" ;
 
   IndicatorShortName(short_name);
 
   SetIndexBuffer(0, P1Buffer);
   SetIndexStyle(0, DRAW_ARROW,STYLE_SOLID,ATR_WIDTH , ATR_COLOR_OPEN );   
   SetIndexArrow(0, ATR_WingDing); 
   
   SetIndexBuffer(1, P2Buffer);
   SetIndexStyle(1, DRAW_ARROW,STYLE_SOLID,ATR_WIDTH , ATR_COLOR_OPEN );
   SetIndexArrow(1, ATR_WingDing); 
 
   SetIndexBuffer(2, P3Buffer);
   SetIndexStyle(2, DRAW_ARROW,STYLE_SOLID,ATR_WIDTH , ATR_COLOR_LOW );   
   SetIndexArrow(2, ATR_WingDing); 
   
   SetIndexBuffer(3, P4Buffer);
   SetIndexStyle(3, DRAW_ARROW,STYLE_SOLID,ATR_WIDTH , ATR_COLOR_HIGH );
   SetIndexArrow(3, ATR_WingDing); 
      
   TRO() ;
   
   
   
   return(0);
}
       

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
   Comment( "" ) ;
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
   return(0);
  }
  
//+------------------------------------------------------------------+

int start()
{
   datetime TimeArray[];
   
   int i ; 
   int limit = Bars - 2;
  
   
   if( ATR_CHART_Period < period) { Comment( "*** ERROR - ATR CHART PERIOD < CHART PERIOD ") ;    return(0) ;  }

   upHits = 0; 
   dnHits = 0; 
   passes = 0 ;
   
   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),ATR_CHART_Period);  
 
  
   for(i=0; i<limit; i++)
   {
      iTF = 0;    
      while(Time[i] < TimeArray[iTF]) iTF++;
       
   
      ATR          = iATR(NULL,ATR_CHART_Period, ATR_Period, iTF) ; // ATR_CHART_Period
      xATR         = ATR * ATR_MULT;
      open         = iOpen(NULL,ATR_CHART_Period,iTF) ;
      high         = iHigh(NULL,ATR_CHART_Period,iTF) ;
      low          = iLow(NULL,ATR_CHART_Period,iTF) ;
      
      PLUSATR      = open + xATR ;
      MINUSATR     = open - xATR ;
      LOWPLUSATR   = low  + xATR ;
      HIGHMINUSATR = high - xATR ;
            
      P1Buffer[i]  = PLUSATR ;
      P2Buffer[i]  = MINUSATR ;
      P3Buffer[i]  = LOWPLUSATR ;
      P4Buffer[i]  = HIGHMINUSATR ;        
               
      passes       = passes + 1 ;
      
      if(high >= PLUSATR) { upHits = upHits + 1 ; }
      if(low  <= MINUSATR) { dnHits = dnHits + 1 ; }
      
   }

if( Show_LABEL )  DoLabel( TAG+"01" , P1Buffer[0]  , ATR_COLOR_OPEN ) ;
if( Show_LABEL )  DoLabel( TAG+"02" , P2Buffer[0]  , ATR_COLOR_OPEN ) ; 

if( Show_COMMENT )
{ 
   close = Close[0];
   range = open + xATR ;
   
   if( xATR > 0.0 && passes > 0)
   {
   xPCT  = 100 * (close - open) / xATR ; //100 * MathAbs(close - open) / range ;
   upPCT = 100 * upHits / passes ;
   dnPCT = 100 * dnHits / passes ;
   
   Comment( "\n",
            "ATR CHART PERIOD " , ATR_CHART_Period, "\n", 
            "ATR(" + ATR_Period + ")= ", DoubleToStr(xATR,Digits), "\n", 
            "ATR Multiplier = ", DoubleToStr(ATR_MULT,Digits), "\n", 
            "ATR % in Range = ", DoubleToStr(xPCT,2), "%\n", 
            ATR_COMMENT,"\n",
            "\n",
            "Bars = ", passes,  "\n",
            "Times High Exceeded ATR = ", upHits, " | ", DoubleToStr(upPCT,2), "%\n", 
            "Times Low Exceeded ATR = ", dnHits,  " | ", DoubleToStr(dnPCT,2), "%\n", 
         "") ;
    } // if xAtr     
} // if

return(0);   
}



//+------------------------------------------------------------------+ 

void DoLabel( string dName, double dValue, color dColor )
{

     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],dValue);
      }
      
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//+------------------------------------------------------------------+ 

 