//+------------------------------------------------------------------+
//|   TRO_BAR_NUMBERS                                                |
//|                                                                  | 
//|   Copyright  2014, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2014, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window 
#property indicator_buffers 4
  
extern bool TURN_OFF    = false ;
  
extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 8 ; 

extern color  myColor      = Blue ;
extern color  myZcolor     = Magenta ;

extern int    myOffset = 0  ;

extern bool PlotAboveBar = false ;
extern bool PlotBelowBar = true ;

extern int myStart = 0  ;
extern int myBars  = 0 ;  


 
//---- buffers

double     H_Buffer[];
double     L_Buffer[];


string SHORTNAME ;
string totOT1 , totOT2, totOT3 ;

string symbol, tChartPeriod,  tShortName ;    
int    digits, period, digits2  ; 


double HH,LL ;

		
   double X01,X03, X04  ;
   double X02  ; 

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011,Obj0012,Obj0013,Obj0014,Obj0015,Obj0016,Obj0017;  

string aHelp[20];
double curr[], prev[] ;
int limit, zSize, i, nHH, nLL;    
double zSpot ;
    
 
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   
 
   SetIndexStyle(0,DRAW_NONE);  
   SetIndexStyle(1,DRAW_NONE); 
   SetIndexStyle(2,DRAW_NONE); 

   SetIndexBuffer(0,H_Buffer);
   SetIndexBuffer(1,curr);
   SetIndexBuffer(2,prev); 

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0); 
   
   
   period = Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;
 
        
     
   SHORTNAME = "TROBAR#" ;
   deinit();
   
   return(0);
  } 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix(SHORTNAME);     
   TRO();   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{
   if( TURN_OFF ) { deinit(); return(0) ; }
   
   if(myBars == 0) { limit = WindowBarsPerChart() ;  } else { limit = myBars ; }
 
 
      nHH     =  Highest(NULL,period,MODE_HIGH,limit,0); 
      nLL     =  Lowest(NULL,period,MODE_LOW,limit,0);     
 
      HH     = iHigh(NULL,period,nHH);  
      LL     = iLow(NULL,period,nLL); 
             

   for(  i=myStart; i<limit; i++)
   {
      curr[i] = i ;
      DoPlotZ( i , curr[i]) ; 
   }   
   
   
   WindowRedraw() ;
   
   return(0);
}


//+------------------------------------------------------------------+ 

void DoPlotZ( int p , double pNum )
{

  string sSHORTNAME = SHORTNAME+ "Z" + p ;
  string sSHORTNAMEb = SHORTNAME+ "Zb" + p ;
  
  string sNum    = DoubleToStr(pNum , 0) ;
 

if(PlotAboveBar)
{  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],HH); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, myZcolor );   
          ObjectSet(sSHORTNAME,OBJPROP_BACK,false) ;
      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],HH);
      }
}


if(PlotBelowBar)
{  
  if (ObjectFind(sSHORTNAMEb) != 0)
      {
          ObjectCreate(sSHORTNAMEb,OBJ_TEXT,0,Time[p],LL); 
          ObjectSetText(sSHORTNAMEb, sNum , myFontSize, myFont, myZcolor );   
          ObjectSet(sSHORTNAMEb,OBJPROP_BACK,false) ;
      } 
      else
      {
         ObjectMove(sSHORTNAMEb,0,Time[p],LL);
      }
} // if

}

//+------------------------------------------------------------------+
 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
  
//+------------------------------------------------------------------+  
 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
/*
Comment(

"limit=" , limit , "\n" ,  
"nHH=" , nHH , "\n" ,  
"nLL=" , nLL , "\n" ,  

"HH " , DoubleToStr(HH,Digits) , "\n" ,  
"LL " , DoubleToStr(LL,Digits) , "\n" ,  

"") ;

*/


