//+------------------------------------------------------------------+ 
//|   TRO_BAR_STATS_IN_A_ROW                                         | 
//|                                                                  | 
//|   Copyright  2016, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern int myChartX   = 10 ;
extern int myChartY   = 100 ;
extern int myCorner   = 1 ;
extern string myFont  = "Courier" ;
extern int myFontSize = 12 ;

extern int myPeriod   = 0 ;
extern int myRows     = 10 ; 
extern int myBars     = 0 ;

extern color  colorHead  = DimGray ;
extern color  colorBULL  = Green;
extern color  colorBEAR  = Red;



int h  ;
string lbl[50], lbl2[50];
int n, j, z   ;

color pColor = Blue ;

string symbol, tChartPeriod, ShortName ,TAG ;  

int    digits, period, win ; 


double point ;
double High0, Low0, Open0,  Close0, Open1,High1, Low1, Close1   ;  
 
 
int     ind_bufferOp[], Stats[11], StatsR[11], StatsG[11],scount, limit;

 
bool red0, red1, green0, green1 ;
      
      
//+------------------------------------------------------------------+

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "iNaRow" ;
   ShortName    =  TAG+symbol+period ;   

   win          =  0 ;
      
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   if(myBars == 0) { limit = 1440 / Period() ; } else  { limit = myBars ; }
   if(limit < 2  ) { limit = 100  ; }
 

   ArrayResize(ind_bufferOp,limit) ;
   
   deinit(); 
   
   return(0);
}
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int ll = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, ll) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}  
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG) ;
   TRO();
   return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

   n       = 10;
   j       = 0 ;
   
   lbl[j]  = ShortName+j;
   lbl2[j] = tChartPeriod + " Bars In A Row(" + limit + ")" ;
   DoShow(j, colorHead);
   
   DoWork( period ) ;
   
   for( j = 1 ; j < myRows+1 ; j++ )
   {
      lbl[j]  = ShortName+j;
      lbl2[j] = j+ " Bars " ;
      DoShow(j, colorHead); 
   }
 
   
   WindowRedraw() ;
   
   return(0);
}

//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{
   ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
   ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
   ObjectSet(lbl[u],OBJPROP_XDISTANCE, myChartX);
   ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
   ObjectSetText(lbl[u],fFill(lbl2[u],24),myFontSize,myFont,dsColor);
   
   if(u > 0)
   {
   
   string rlabel = lbl[u] + "red"  ;
   ObjectCreate(rlabel,23,0,Time[0],PRICE_CLOSE);
   ObjectSet(rlabel, OBJPROP_CORNER, myCorner );
   ObjectSet(rlabel,OBJPROP_XDISTANCE, 40+myChartX);
   ObjectSet(rlabel,OBJPROP_YDISTANCE,n+myChartY);
   ObjectSetText(rlabel,""+StatsR[u],myFontSize,myFont,colorBEAR);
   
   string glabel = lbl[u] + "green"  ;
   ObjectCreate(glabel,23,0,Time[0],PRICE_CLOSE);
   ObjectSet(glabel, OBJPROP_CORNER, myCorner );
   ObjectSet(glabel,OBJPROP_XDISTANCE, 100+myChartX);
   ObjectSet(glabel,OBJPROP_YDISTANCE,n+myChartY);
   ObjectSetText(glabel,""+StatsG[u],myFontSize,myFont,colorBULL);
   }
   
   n = n+20;
    
}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

   if(c1 > c2 ) { pColor = Lime ; } else {
   if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}  
  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, myFontSize, myFont , EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}

//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
void DoWork( int wPeriod )
{
   for(int i=limit-1; i >= 0; i--) 
   {  
      ind_bufferOp[i] = 0 ;             
   } 
   
   for( i = 0 ; i <=11; i++ ) 
   { 
      Stats[i] = 0 ; 
      StatsR[i] = 0 ; 
      StatsG[i] = 0 ;
   }
     
     
     
   for( i=1; i <= limit; i++)
   {
   
      scount = 1 ;
      
      Open0   = iOpen(NULL,wPeriod,i) ;      
      Close0  = iClose(NULL,wPeriod,i) ;
      
      if(Close0 >= Open0) { green0 = true; red0 = false ; } else { green0 = false ; red0 = true;  } 
      
      for( z=i+1; z <= limit; z++)
      {
         Open1   = iOpen(NULL,wPeriod,z) ;
         Close1  = iClose(NULL,wPeriod,z) ;
         
         if(Close1 >= Open1) { green1 = true; red1 = false ; } else { green1 = false ; red1 = true;  } 
         
         if( green1 != green0) { break ; }
         
         scount = scount + 1 ;
      }
      
 
      if( green0 ) { StatsG[scount] = StatsG[scount] + 1 ;  }    
      else         { StatsR[scount] = StatsR[scount] + 1 ;  }  
      
      i = z-1 ;     
              
   } 


}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
   return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

   return(rString) ;
}       
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+

/*

Comment(

"ind_bufferOp[0]" , ind_bufferOp[0] , "\n" ,   
"Open0 " , DoubleToStr(Open0,Digits) , "\n" ,  
"Close0 " , DoubleToStr(Close0,Digits) , "\n" ,   
"Open1 " , DoubleToStr(Open1,Digits) , "\n" ,  
"Close1 " , DoubleToStr(Close1,Digits) , "\n" ,   

"") ; 
*/