//+------------------------------------------------------------------+ 
//|   TRO_D1H1_TURN                                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1

//---- indicator parameters  
extern bool TURN_OFF    = false ;

extern int win            = 0;
extern int corner         = 3;
extern int price_x_offset = 0 ; 
extern int price_y_offset = 100 ; 

extern string myFont          = "Arial Bold" ;
extern int   myFontSize       = 16;


extern string Buy_Message  = "D1H1 - ONLY TRADE LONG " ;
extern string Wait_Message = "D1H1 - *** WAIT ***    " ;
extern string Sell_Message = "D1H1 - ONLY TRADE SHORT" ;
//extern string Rdy_Message  = "D1H1 - *** GET READY *** " ;

extern color Buy_color  = Lime;
extern color Wait_color = DimGray;
extern color Sell_color = Red;
//extern color Rdy_color  = Orange;

string tMessage , oldmsg = "" ; 

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

datetime Trigger ;

int OldBars = -1 ;

color tColor = Yellow ;
 
color ClOpColor;

double H1_open, H1_close, open, close, diff, spread, DailyOpen ;

string tObjName03 = "TROH1D1T"  ; 
  
   bool    twGREEN, twRED, D1GREEN, H1GREEN, OKtoSell, OKtoBuy;  
//+------------------------------------------------------------------+ 
int init() 
  { 
   period       = Period() ;     
//   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   

   tShortName = "H1D1T"+ symbol + tChartPeriod  ;
   deinit() ;
   
   return(0); 
  } 
//+------------------------------------------------------------------+ 

int deinit() 
{ 

   ObjectDelete("TRAIN30");
   ObjectDelete("TRAIN29");
   ObjectDelete("TRAIN29B");
   ObjectDelete("TRAIN31");
   ObjectDelete("TRAIN32");
   ObjectDelete("TRAIN34");   
   ObjectDelete(tObjName03);     
   TRO() ;
    
   return(0);   
}  
 
//+------------------------------------------------------------------+ 
int start() 
{ 
   if( TURN_OFF ) { deinit(); return(0) ; }
      
 
   D1GREEN  = iClose(symbol,PERIOD_D1,0) > iOpen(symbol,PERIOD_D1,0) ;
   H1GREEN  = iClose(symbol,PERIOD_H1,1) > iOpen(symbol,PERIOD_H1,1) ; 
   twGREEN  = iClose(symbol,PERIOD_H1,0) > iOpen(symbol,PERIOD_H1,0) ; 
   twRED    = iClose(symbol,PERIOD_H1,2) > iOpen(symbol,PERIOD_H1,2) ;  
   
   OKtoBuy  = D1GREEN && H1GREEN && twGREEN && !twRED ;
   OKtoSell = !D1GREEN && !H1GREEN && !twGREEN && twRED ;
   
while(true)
{

if( OKtoBuy ) { tMessage = Buy_Message  ; ClOpColor = Buy_color  ; break ; }
 
if( OKtoSell ) { tMessage = Sell_Message ; ClOpColor = Sell_color ; break ; } 

tMessage = Wait_Message ; ClOpColor = Wait_color ; 

break;

} // while

tMessage = fFill(tMessage,20) ;

oldmsg =  tMessage ;



//+------------------------------------------------------------------+  
                    
   ObjectCreate("TRAIN31", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("TRAIN31",tMessage, myFontSize , myFont, ClOpColor );
   ObjectSet("TRAIN31", OBJPROP_CORNER, corner);
   ObjectSet("TRAIN31", OBJPROP_XDISTANCE, price_x_offset); 
   ObjectSet("TRAIN31", OBJPROP_YDISTANCE, price_y_offset); 

/*
 string note2 = "Default Font Color";
 color  twFontColor              = DimGray;
 string note3                  = "Font Size";
 int twFontSize                  = 8;
 string note4                  = "Font Type";
 string twFontType               = "Verdana"; // Tahoma Courier
 string RAN953 =  "*** TRO TRAINING WHEELS ***"  ;   

    
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, RAN953 , twFontSize ,  twFontType,  twFontColor );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 15 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 10 ); 
*/   
//+------------------------------------------------------------------+        

   WindowRedraw();   
    
   return(0);
}
 
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+


/*
 

Comment(

 
"DailyOpen " , DoubleToStr(DailyOpen,Digits) , "\n" ,
 

"") ; 

 
*/