//+------------------------------------------------------------------+ 
//|   TRO_INTERNAL_EZ                                                | 
//|                                                                  | 
//|   Copyright  2009, AVERY T. HORTON, JR. AKA TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1



//---- indicator parameters  
//extern int   Threshold       = 20; 

extern  bool Show_Help  = false ;
extern color colorHelp  = Orange ;

//extern bool LiteVersion  = false ;

extern int win           = 0;
extern int price_x_offset= 100 ; //250
extern int price_y_offset= 10 ; //-160


extern int   myPeriod    = 0;
extern int   MaxBars         = 24;

extern string Ind_Name_1 ="iATR";

extern double iParm3 = 14;
extern double iParm4 = 0 ;
extern double iParm5 = 0;
extern double iParm6 = 0;
extern double iParm7 = 0;
extern double iParm8 = 0;


extern string myFont        = "Arial Bold" ;
extern int myFontSize       = 25;




extern color ColorHeading    =  Gray ; 
extern color ColorRange      = LightGray ; 
extern color ThresholdColor  = LimeGreen; 
extern color ColorABAvg      =  DarkViolet ;    
extern color ColorAvg        =  Orange ;  
extern color ColorABCur      =  Blue ; 
extern color ColorMinMax      =  Chocolate ; 



//---- indicator buffers 


double     MaxRange = 0 ; 
double     MinRange = 0 ; 
double     AvgRange = 0 ; 
double     xRange   = 0 ; 
double     tRange   = 0 ; 



//---- buffers


double zRange = 0;

bool  Show_info       = true;
bool  ShowChart       = true; 

double   AboveAvg, BelowAvg, AboveCur, BelowCur ;

double xRet, close, point ;
double xRetPct, cVal, pVal ;  

int    digits2, digits   ; 
string  symbol, tPeriod ;
string HELPTAG, TAG, OBJ0001, OBJ0002, OBJ0003, OBJ0004, OBJ0005, OBJ0006, OBJ0007, OBJ0008 ; 

string aHelp[15];
 
//+------------------------------------------------------------------+ 
int init() 
  { 
   
   if(myPeriod == 0 ) { myPeriod = Period() ;}

   tPeriod = " "+TimeFrameToString( myPeriod ) ;

   digits       =  Digits ;   
   point        =  Point ;   
  if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } else { digits2 = 0 ; }
    

   
   TAG     = Ind_Name_1 + tPeriod + MaxBars + iParm3 ;
   
   
   OBJ0001 = TAG + "001" ;
   OBJ0002 = TAG + "002" ;
   OBJ0003 = TAG + "003" ;
   OBJ0004 = TAG + "004" ;
   OBJ0005 = TAG + "005" ;
   OBJ0006 = TAG + "006" ;
   OBJ0007 = TAG + "007" ;
   OBJ0008 = TAG + "008" ;    
   
   if(Show_Help) { DoHelp () ; } else { deinit() ; }   
   
   return(0); 
  } 

  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
  
int deinit() 
{ 
  
  ObDeleteObjectsByPrefix(Ind_Name_1);   
   return(0);    
}  
 
//+------------------------------------------------------------------+ 
int start() 
  { 


    MaxRange = 0 ; 
    MinRange = 999999 ; 

   int limit; 
   int counted_bars=IndicatorCounted(); 
    
//---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 
   if(counted_bars<0) return(-1); 
   

   AboveAvg = 0 ; 
   BelowAvg = 0 ; 
   AboveCur = 0 ; 
   BelowCur  = 0 ;
  
   limit = MaxBars + 1;  

//---- RANGE counted in the 1-st buffer 


		double buf_tmp = 0 ;
		int z = 0 ;

    DoInternal( symbol,myPeriod , 0 ) ;
     
    zRange =  cVal ;

   for(int i=1; i<limit; i++) 
   { 

     DoInternal( symbol,myPeriod , i ) ;

     xRange   = cVal ;

     tRange = xRange ;
     
     buf_tmp =  buf_tmp + xRange ;
 
     
     if( tRange > MaxRange ) {MaxRange = tRange  ; }
     if( tRange < MinRange ) {MinRange = tRange  ; }  
    
     if( tRange > AvgRange ) {AboveAvg = AboveAvg + 1  ; }
     if( tRange < AvgRange ) {BelowAvg = BelowAvg + 1  ; }     

     if( tRange > zRange ) {AboveCur = AboveCur + 1  ; }
     if( tRange < zRange ) {BelowCur = BelowCur + 1  ; }     
                 
   } 

   AvgRange = buf_tmp / MaxBars ; // average range 

     
   
   xRetPct =  ( 100 ) * ( zRange / AvgRange )  ;  
   
 DoShowInfo() ;  



   return(0);
} 


                                                                                                             

//+------------------------------------------------------------------+

void DoInternal( string IntPair, int IntPeriod, int iShift )  
{

double cX, pX ;

while(true)
{

if ( Ind_Name_1=="tMid"  ) { cVal = (iHigh(IntPair, IntPeriod, 0 ) + iLow(IntPair, IntPeriod, 0 ) ) * 0.5  ; 
                             pVal = (iHigh(IntPair, IntPeriod, 1 ) + iLow(IntPair, IntPeriod, 1 ) ) * 0.5  ;  break;}

if ( Ind_Name_1=="tPrMid"  ) { cVal = (iHigh(IntPair, IntPeriod, 1 ) + iLow(IntPair, IntPeriod, 1 ) ) * 0.5  ; 
                             pVal = (iHigh(IntPair, IntPeriod, 2 ) + iLow(IntPair, IntPeriod, 2 ) ) * 0.5  ;  break;}

if ( Ind_Name_1=="tCLOP"  ) { cVal = iClose(IntPair, IntPeriod, 0 ); pVal = iOpen(IntPair, IntPeriod, 0 ); break;}



if ( Ind_Name_1=="iOpen"  ) { cVal = iOpen(IntPair, IntPeriod, iParm3 ); pVal = iOpen(IntPair, IntPeriod, iParm3+1 ); break;}

if ( Ind_Name_1=="iClose"  ) { cVal = iClose(IntPair, IntPeriod, iParm3 ); pVal = iClose(IntPair, IntPeriod, iParm3+1 ); break;}

if ( Ind_Name_1=="iHigh"  ) { cVal = iHigh(IntPair, IntPeriod, iParm3 ); pVal = iHigh(IntPair, IntPeriod, iParm3+1 ); break;}

if ( Ind_Name_1=="iLow"  )  { cVal = iLow(IntPair, IntPeriod, iParm3 );  pVal = iLow(IntPair, IntPeriod, iParm3+1 ); break;}

if ( Ind_Name_1=="iHighest"  ) { cX = iHighest(IntPair, IntPeriod, iParm3, iParm4, iParm5 );    cVal = iHigh(IntPair, IntPeriod, cX ) ;
                                 pX = iHighest(IntPair, IntPeriod, iParm3, iParm4, iParm5+1 );  pVal = iHigh(IntPair, IntPeriod, pX );  break;}
                                 
if ( Ind_Name_1=="iLowest"  )  { cX = iLowest(IntPair, IntPeriod, iParm3, iParm4, iParm5);    cVal = iLow(IntPair, IntPeriod, cX ) ;
                                 pX = iLowest(IntPair, IntPeriod, iParm3, iParm4, iParm5+1 ); pVal = iLow(IntPair, IntPeriod, pX ) ; break;}



if ( Ind_Name_1=="iAC"  ) { cVal = iAC(IntPair, IntPeriod, iShift ); pVal = iAC(IntPair, IntPeriod, iShift + 1 ); break;}
                            
if ( Ind_Name_1=="iAD"  ) { cVal = iAD(IntPair, IntPeriod, iShift ); pVal = iAD(IntPair, IntPeriod, iShift + 1 ); break;}
 
if ( Ind_Name_1=="iADX" ) { cVal = iADX(IntPair,IntPeriod, iParm3, iParm4, iParm5, iShift ) ;  
                            pVal = iADX(IntPair,IntPeriod, iParm3, iParm4, iParm5, iShift + 1 ) ; break;}

if ( Ind_Name_1=="iATR" ) { cVal = iATR(IntPair,IntPeriod, iParm3,  iShift ) / point ;  
                            pVal = iATR(IntPair,IntPeriod, iParm3, iShift + 1 ) / point ; break;} 
                            
if ( Ind_Name_1=="iAO" )  { cVal = iAO(IntPair,IntPeriod, iShift ) ;  
                            pVal = iAO(IntPair,IntPeriod,  iShift + 1 ) ; break;} 
                            
if ( Ind_Name_1=="iBearsPower" ) { cVal = iBearsPower(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                                   pVal = iBearsPower(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;}  

if ( Ind_Name_1=="iBullsPower" ) { cVal = iBullsPower(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                                   pVal = iBullsPower(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;}  

if ( Ind_Name_1=="iCCI" ) { cVal = iCCI(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                            pVal = iCCI(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;}  

if ( Ind_Name_1=="iDeMarker" ) { cVal = iDeMarker(IntPair,IntPeriod, iParm3,  iShift ) ;  
                                 pVal = iDeMarker(IntPair,IntPeriod, iParm3,  iShift + 1 ) ; break;}  

if ( Ind_Name_1=="iRSI" ) { cVal = iRSI(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                            pVal = iRSI(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;}  

if ( Ind_Name_1=="iForce" ) { cVal = iForce(IntPair,IntPeriod, iParm3, iParm4, iParm5, iShift ) ;  
                              pVal = iForce(IntPair,IntPeriod, iParm3, iParm4, iParm5, iShift + 1 ) ; break;}

if ( Ind_Name_1=="iFractals" ) { cVal = iFractals(IntPair,IntPeriod, iParm3,  iShift ) ;  
                                 pVal = iFractals(IntPair,IntPeriod, iParm3,  iShift + 1 ) ; break;} 

if ( Ind_Name_1=="iBWMFI" )  { cVal = iBWMFI(IntPair,IntPeriod, iShift ) ;  
                               pVal = iBWMFI(IntPair,IntPeriod,  iShift + 1 ) ; break;} 
                               
if ( Ind_Name_1=="iMomentum" ) { cVal = iMomentum(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                                 pVal = iMomentum(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;}                                 
                               

if ( Ind_Name_1=="iMFI" ) { cVal = iMFI(IntPair,IntPeriod, iParm3,  iShift ) ;  
                            pVal = iMFI(IntPair,IntPeriod, iParm3,  iShift + 1 ) ; break;}                                
                               
if ( Ind_Name_1=="iMA" ) { cVal = iMA(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iShift ) ;  
                           pVal = iMA(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iShift + 1 ) ; break;}
                              
                              
if ( Ind_Name_1=="iOsMA" ) { cVal = iOsMA(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iShift ) ;  
                             pVal = iOsMA(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iShift + 1 ) ; break;}   
                             
                             
if ( Ind_Name_1=="iMACD" ) { cVal = iMACD(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iParm7, iShift ) ;  
                             pVal = iMACD(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iParm7, iShift + 1 ) ; break;}                               
                                                             

if ( Ind_Name_1=="iOBV" ) { cVal = iOBV(IntPair,IntPeriod, iParm3,  iShift ) ;  
                            pVal = iOBV(IntPair,IntPeriod, iParm3,  iShift + 1 ) ; break;} 


if ( Ind_Name_1=="iSAR" ) { cVal = iSAR(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                            pVal = iSAR(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;} 

if ( Ind_Name_1=="iRVI" ) { cVal = iRVI(IntPair,IntPeriod, iParm3, iParm4,  iShift ) ;  
                            pVal = iRVI(IntPair,IntPeriod, iParm3, iParm4,  iShift + 1 ) ; break;} 

if ( Ind_Name_1=="iStdDev" ) { cVal = iStdDev(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iShift ) ;  
                               pVal = iStdDev(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iShift + 1 ) ; break;} 
                                                              

if ( Ind_Name_1=="iStochastic" ) { cVal = iStochastic(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iParm7, iParm8, iShift ) ;  
                                   pVal = iStochastic(IntPair,IntPeriod, iParm3, iParm4, iParm5, iParm6, iParm7, iParm8, iShift + 1 ) ; break;}                               
                                                             
if ( Ind_Name_1=="iWPR" ) { cVal = iWPR(IntPair,IntPeriod, iParm3,  iShift ) ;  
                            pVal = iWPR(IntPair,IntPeriod, iParm3,  iShift + 1 ) ; break;} 

break;
                                
//IndHead = "ERROR! NO SUCH INDICATOR"; cVal = -999.99;  break;
}                                
         

}

//+------------------------------------------------------------------+ 
   
void DoShowInfo()

{



tPeriod = " "+TimeFrameToString( myPeriod ) ;

if ( zRange > AvgRange ) { color RangeColor = ThresholdColor ; } else { RangeColor = ColorRange   ; }


string  RAN931 = DoubleToStr(zRange,0)+" "+ tPeriod + " " + DoubleToStr(xRetPct,0) + "%" ;
                   
   ObjectCreate(OBJ0001, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(OBJ0001, RAN931 , myFontSize , myFont, RangeColor );
   ObjectSet(OBJ0001, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0001, OBJPROP_XDISTANCE, 5+price_x_offset); // 765
   ObjectSet(OBJ0001, OBJPROP_YDISTANCE, 60+price_y_offset); 

//if( !LiteVersion )
//{

   ObjectCreate(OBJ0002, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(OBJ0002,tPeriod + " " + Ind_Name_1 + "("+MaxBars+")", 20, myFont, ColorHeading);
   ObjectSet(OBJ0002, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0002, OBJPROP_XDISTANCE, 0+price_x_offset);
   ObjectSet(OBJ0002, OBJPROP_YDISTANCE, 0+price_y_offset);

string  RAN929 = DoubleToStr( MaxRange ,0) + " / " + DoubleToStr( MinRange ,0) ;    

   ObjectCreate(OBJ0003, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(OBJ0003,RAN929, 15, myFont, ColorMinMax  );
   ObjectSet(OBJ0003, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0003, OBJPROP_XDISTANCE, 10+price_x_offset);
   ObjectSet(OBJ0003, OBJPROP_YDISTANCE, 37+price_y_offset);

string  RAN929b = DoubleToStr( AboveCur ,0) + " / " + DoubleToStr( BelowCur ,0) ; 
 
  
   ObjectCreate(OBJ0004, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(OBJ0004, RAN929b , 15, myFont, ColorABCur );
   ObjectSet(OBJ0004, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0004, OBJPROP_XDISTANCE, 10+price_x_offset);
   ObjectSet(OBJ0004, OBJPROP_YDISTANCE, 100+price_y_offset);                 
                   
                   
           

   ObjectCreate(OBJ0005, OBJ_LABEL, win, 0, 0);   // 
   ObjectSetText(OBJ0005,DoubleToStr( AvgRange ,2), 15, myFont, ColorAvg); // RANGEBuffer2[0] buf0[0]
   ObjectSet(OBJ0005, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0005, OBJPROP_XDISTANCE, 100+price_x_offset);
   ObjectSet(OBJ0005, OBJPROP_YDISTANCE, 37+price_y_offset);
                 
string  RAN934 = DoubleToStr( AboveAvg ,0) + " / " + DoubleToStr( BelowAvg ,0) ;                
           
   ObjectCreate(OBJ0006, OBJ_LABEL, win, 0, 0);
   ObjectSetText(OBJ0006, RAN934 , 15, myFont,  ColorABAvg);
   ObjectSet(OBJ0006, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0006, OBJPROP_XDISTANCE, 90+price_x_offset);
   ObjectSet(OBJ0006, OBJPROP_YDISTANCE, 100+price_y_offset);    
    
//} // if( !LiteVersion )


WindowRedraw();    
 
 

   return; 
} 

//+------------------------------------------------------------------+

 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
  

//+------------------------------------------------------------------+  

void DoHelp()
{




aHelp[0] = "TRO_INTERNAL_EZ" ;
aHelp[1] = "Heading displays # of bars counted. " ;
aHelp[2] = "Top Left = Maximum /  Minimum Value. " ;
aHelp[3] = "Top Right = Average Value. " ;
aHelp[4] = "Bottom Left = # bars above / below CURRENT VALUE.  " ;
aHelp[5] = "Bottom Right = # bars above / below AVERAGE VALUE. " ;
aHelp[6] = " " ;
aHelp[7] = "  " ;
aHelp[8] = "Big numbers are the Current VALUE and Percent of Average VALUE." ;  
aHelp[9]  = " " ;
aHelp[10] = "  " ;
aHelp[11] = "  " ;
aHelp[12] = " " ;
aHelp[13] = "Note that the Minimum, Maximum and Average VALUE" ;
aHelp[14] = "DO NOT INCLUDE the current bar " ;



for( int h = 0 ; h < 15 ; h++ )
{
   drawComment(Ind_Name_1+"aHelp"+h,aHelp[h] , 10, 120 + 20*h , colorHelp  ) ;
} 

}

//+------------------------------------------------------------------+  
 
void drawComment(string tLabel,string name, int xPos, int yPos ,color Color  )
{

ObjectCreate(tLabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(tLabel, OBJPROP_CORNER, 0 );
ObjectSet(tLabel,OBJPROP_XDISTANCE,xPos);
ObjectSet(tLabel,OBJPROP_YDISTANCE,yPos);
ObjectSetText(tLabel,name,12,"Courier New",Color); 
}

//+------------------------------------------------------------------+ 
 