//+------------------------------------------------------------------+ 
//|   TRO_Jacko_Trend_Plot                                           | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//| DO NOT DISTRIBUTE THIS CODE BY ANY MEANS - tell people to        |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
#property description "TRO - TheRumpledOne" 
#property description "DO NOT POST THIS ON OTHER FORUMS" 
#property description "www.kreslik.com is where TRO indicators can be found" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- indicator parameters

extern bool TURN_OFF    = false ;

extern bool Show_Comment = true ; 
extern int  myBars      = 0;

extern int   Trend_Style = 0 ; 
extern int   Trend_Width = 2 ;
extern color colorTrend  = Yellow;

extern color colorUp =  Lime ;
extern color colorEq =  Yellow ;
extern color colorDn =  Red ;

string symbol, tChartPeriod,  tShortName ;  
int    digits, period, digits2  ; 
double point ;
 

int xBarsPerChart , barsToCount   ; 
int xFirstVisibleBar  ; 
double xPriceMax     ; 
double xPriceMin     ;

double Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2, Range0, Range1, Range2, AvgRng3 ;
		
string OBJ001, tTrend ;

//+------------------------------------------------------------------+
int init()
{ 
    period = Period() ;     
//   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
       
   OBJ001 = "JackoTREND1" ;
 
    
   return(0);
  }
//+------------------------------------------------------------------+  
int deinit() 
{

	ObjectDelete(OBJ001);
	TRO();
	return(0);
}
//+------------------------------------------------------------------+
int start()
{   
   deinit() ;
   
   if( TURN_OFF ) {  return(0) ; }
   
   
   xBarsPerChart    = WindowBarsPerChart() ; 
   xFirstVisibleBar = WindowFirstVisibleBar() ; 
   xPriceMax        = WindowPriceMax() ; 
   xPriceMin        = WindowPriceMin() ;
  
if(myBars == 0) { barsToCount = WindowBarsPerChart() ; } else { barsToCount = myBars; }



   Close0 = iClose(symbol,period,0) ;   
   Open0  = iOpen(symbol,period,barsToCount) ; 

   if( Close0 >= Open0 ) {   colorTrend = colorUp; tTrend = "UP" ; } 
   else {  colorTrend = colorDn ; tTrend = "DOWN" ; }
   
   ObjectCreate(OBJ001, OBJ_TREND, 0,Time[barsToCount],Open0,Time[0],Close0 );
   ObjectSet(OBJ001, OBJPROP_COLOR, colorTrend);
   ObjectSet(OBJ001, OBJPROP_STYLE, Trend_Style);
   ObjectSet(OBJ001, OBJPROP_WIDTH, Trend_Width);
 
   if(Show_Comment)
   {    	   
      Comment(  
      "Bars Used    =  ", barsToCount, " ",
      "Price Open  = ", DoubleToStr(Open0   , digits  ) , " ",  
      "Price Close = ", DoubleToStr(Close0   , digits  ) , "\n",  
      "Price Max   = ", DoubleToStr(xPriceMax   , digits  ) , " ", 
      "Price Min   = ", DoubleToStr(xPriceMin   , digits  ) , "\n",
      "A 5 year old would say: TREND IS ", tTrend , "\n",
      "");
   }
   
   WindowRedraw() ;

return(0);   
}


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+


  
   