//+------------------------------------------------------------------+ 
//|   TRO_Multi_Meter_PrevMid                                        | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTs AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+  

#property indicator_chart_window

extern bool Show_Heading = true;
 
extern string IndName = "PrMid" ; // change

extern bool Corner_of_Chart_RIGHT_TOP = true;

extern int myWindow = 0; 
extern int Shift_UP_DN =30; 
extern int Adjust_Side_to_side  = 20; // 20

extern color BarLabel_color     = DimGray;
extern color ChartPeriod_color  = Magenta;

extern color Up_color  = Green;
extern color Eq_color  = DimGray;
extern color Dn_color  = Red;
 
 
 
//*******************

string ObjHead01,ObjHead02,ObjHead03,ObjHead04,ObjHead05,ObjHead06,ObjHead07,ObjHead08,ObjHead09,ObjHead10,ObjHead11;  

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

string LabelTime="";


   string CAN_ObjHead01 ="M1 " ;
   string CAN_ObjHead02 ="M5  " ;     
   string CAN_ObjHead03 ="M15 " ;
   string CAN_ObjHead04 =" M30 " ;
   string CAN_ObjHead05 ="H1  " ;     
   string CAN_ObjHead06 ="H4  " ;
   string CAN_ObjHead07 ="D1  " ;
   string CAN_ObjHead08 ="W1  " ;
   string CAN_ObjHead09 ="MN1" ;  

double Bias_Open, Bias_Close, Bias_High, Bias_Low, Bias_Diff, Bias_Mid, Bias_Pivot, Bias_PrMid,  CLOSE ;

color HEADINGCOLOR ;

//+---------------
color prDiff(int i, int j)
{
  color _color = Yellow ;

      CLOSE        = Close[0] ;

      Bias_Close   = iClose(NULL,i,j) ;   // close of the chart period
      Bias_Open    = iOpen(NULL,i,j) ;    // open of the Bias period  
      Bias_High    = iHigh(NULL,i,j) ;    // high of the Bias period 
      Bias_Low     = iLow(NULL,i,j) ;     // low of the Bias period 
      
      Bias_PrMid   = ( Bias_High + Bias_Low ) * 0.50 ;
      
       
   while(true)
   {
   if (CLOSE > Bias_PrMid ) { _color = Up_color ; break; } // strong up
   if (CLOSE < Bias_PrMid ) { _color = Dn_color ; break; } // strong down
                              _color = Eq_color  ; break;   // no bias
   } 
   
   
  return (_color);
}

//+------------------------------------------------------------------+
int init()
  {
//---- 
   period       = Period() ;   
   tChartPeriod = TimeFrameToString(period) ;
   symbol       = Symbol() ;
   LabelTime    = symbol + tChartPeriod  ;  

   ObjHead01 = "PrMidColHead01"  ; 
   ObjHead02 = "PrMidColHead02"  ; 
   ObjHead03 = "PrMidColHead03"  ; 
   ObjHead04 = "PrMidColHead04"  ; 
   ObjHead05 = "PrMidColHead05"  ; 
   ObjHead06 = "PrMidColHead06"  ; 
   ObjHead07 = "PrMidColHead07"  ; 
   ObjHead08 = "PrMidColHead08"  ; 
   ObjHead09 = "PrMidColHead09"  ; 

   Obj0002 = "PrMidSignalM1t" ; 
   Obj0003 = "PrMidSignalM1" ;  
   Obj0004 = "PrMidSignalM5" ;  
   Obj0005 = "PrMidSignalM15" ;    
   Obj0006 = "PrMidSignalM30" ;    
   Obj0007 = "PrMidSignalM60" ;     
   Obj0008 = "PrMidSignalM240" ;   
   Obj0009 = "PrMidSignalM1440" ;   
   Obj0010 = "PrMidSignalW1" ;  
   Obj0011 = "PrMidSignalMN1" ;      
          
   deinit(); 


   
//----
   return(0);
  }


//+------------------------------------------------------------------+
int start()
{    

 
        
    if (Corner_of_Chart_RIGHT_TOP == true)
    { int Col01x = 170+Adjust_Side_to_side ;                 
      int Col01y = 28+Shift_UP_DN ;
    }
    if (Corner_of_Chart_RIGHT_TOP == false)
   { Col01x = 159+Adjust_Side_to_side ;       
     Col01y = 24+Shift_UP_DN ;
    } 
    
   int ColAdj = -20 ; 
   int Col02x = Col01x + ColAdj ;   
   int Col03x = Col01x + ColAdj*2 ; 
   int Col04x = Col01x + ColAdj*3 ; 
   int Col05x = Col01x + ColAdj*4 ; 
   int Col06x = Col01x + ColAdj*5 ; 
   int Col07x = Col01x + ColAdj*6 ;    
   int Col08x = Col01x + ColAdj*7 ; 
   int Col09x = Col01x + ColAdj*8 ;     
   
   
   if ( Show_Heading) 
   {        
      if(Period() == PERIOD_M1 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
   
   ObjectCreate(ObjHead01, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead01,CAN_ObjHead01 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead01, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead01, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(ObjHead01, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_M5 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
   
   ObjectCreate(ObjHead02, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead02,CAN_ObjHead02 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead02, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead02, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(ObjHead02, OBJPROP_YDISTANCE, Col01y);   
   
      if(Period() == PERIOD_M15 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
         
   ObjectCreate(ObjHead03, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead03,CAN_ObjHead03 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead03, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead03, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(ObjHead03, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_M30 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
   
   ObjectCreate(ObjHead04, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead04,CAN_ObjHead04 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead04, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead04, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(ObjHead04, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_H1 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
      
   ObjectCreate(ObjHead05, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead05,CAN_ObjHead05 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead05, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead05, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(ObjHead05, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_H4 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
               
   ObjectCreate(ObjHead06, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead06,CAN_ObjHead06 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead06, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead06, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(ObjHead06, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_D1 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
   
   ObjectCreate(ObjHead07, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead07,CAN_ObjHead07 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead07, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead07, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(ObjHead07, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_W1 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
            
   ObjectCreate(ObjHead08, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead08,CAN_ObjHead08 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead08, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead08, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(ObjHead08, OBJPROP_YDISTANCE, Col01y); 
   
      if(Period() == PERIOD_MN1 ) { HEADINGCOLOR = ChartPeriod_color ; } else { HEADINGCOLOR = BarLabel_color ; } 
   
   ObjectCreate(ObjHead09, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead09,CAN_ObjHead09 , 7, "Tahoma Narrow", HEADINGCOLOR);
   ObjectSet(ObjHead09, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead09, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(ObjHead09, OBJPROP_YDISTANCE, Col01y); 
       
} // Show_Heading
 
 
 
    
    string M1_Bias= "-",M5_Bias= "-", M15_Bias= "-", M30_Bias= "-", H1_Bias= "-", H4_Bias= "-", D1_Bias= "-", W1_Bias= "-", MN1_Bias= "-";

    color  color_Biasm1,color_Biasm5,color_Biasm15,color_Biasm30,color_BiasH1,color_BiasH4,color_BiasD1,color_BiasW1,color_BiasMN1;     
         

   //Bias Signals

 
    color_Biasm1  = prDiff( PERIOD_M1, 1 );
    color_Biasm5  = prDiff( PERIOD_M5, 1 );
    color_Biasm15 = prDiff( PERIOD_M15, 1 );
    color_Biasm30 = prDiff( PERIOD_M30, 1 );
    color_BiasH1  = prDiff( PERIOD_H1, 1 );
    color_BiasH4  = prDiff( PERIOD_H4, 1 ); 
    color_BiasD1  = prDiff( PERIOD_D1, 1 );
    color_BiasW1  = prDiff( PERIOD_W1, 1 );
    color_BiasMN1 = prDiff( PERIOD_MN1, 1 );
 

    
 //*******************          
    
    int Col00x = Col01x + 20 ;
    int Col00y = 50+Shift_UP_DN ;
    
    Col01y = 20+Shift_UP_DN ;

             
           ObjectCreate(Obj0002, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0002,IndName, 7, "Tahoma Narrow",  BarLabel_color);  
   ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0002, OBJPROP_XDISTANCE, Col00x);
   ObjectSet(Obj0002, OBJPROP_YDISTANCE, Col00y);  // 50+Shift_UP_DN

      
           ObjectCreate(Obj0003, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0003, M1_Bias, 40, "Tahoma Narrow",  color_Biasm1);
   ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0003, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(Obj0003, OBJPROP_YDISTANCE, Col01y); 

          
           ObjectCreate(Obj0004, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0004, M5_Bias, 40, "Tahoma Narrow",  color_Biasm5);
   ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0004, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(Obj0004, OBJPROP_YDISTANCE, Col01y); 
      

   ObjectCreate(Obj0005, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0005, M15_Bias, 40, "Tahoma Narrow",  color_Biasm15);
   ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0005, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(Obj0005, OBJPROP_YDISTANCE, Col01y); 
      

   ObjectCreate(Obj0006, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0006, M30_Bias, 40, "Tahoma Narrow",  color_Biasm30);
   ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0006, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(Obj0006, OBJPROP_YDISTANCE, Col01y); 

    
           ObjectCreate(Obj0007, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0007, H1_Bias, 40, "Tahoma Narrow",  color_BiasH1);
   ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0007, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(Obj0007, OBJPROP_YDISTANCE, Col01y); 

          
           ObjectCreate(Obj0008, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0008, H4_Bias, 40, "Tahoma Narrow",  color_BiasH4);
   ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0008, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(Obj0008, OBJPROP_YDISTANCE, Col01y);

    
           ObjectCreate(Obj0009, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0009, D1_Bias, 40, "Tahoma Narrow",  color_BiasD1);
   ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0009, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(Obj0009, OBJPROP_YDISTANCE, Col01y);
   
    
           ObjectCreate(Obj0010, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0010, W1_Bias, 40, "Tahoma Narrow",  color_BiasW1);
   ObjectSet(Obj0010, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0010, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(Obj0010, OBJPROP_YDISTANCE, Col01y);   
   
   
           ObjectCreate(Obj0011, OBJ_LABEL, myWindow, 0, 0);
   ObjectSetText(Obj0011, MN1_Bias, 40, "Tahoma Narrow",  color_BiasMN1);
   ObjectSet(Obj0011, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0011, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(Obj0011, OBJPROP_YDISTANCE, Col01y); 
   
   WindowRedraw() ;  
      
   return(0);
  }
//+------------------------------------------------------------------+

int deinit()
  {
 
   deleteObject() ;
   TRO() ;

   return(0);
  }

//+------------------------------------------------------------------+
  
void deleteObject()
  { 
//ObjectDelete(Obj0001);  
ObjectDelete(Obj0002); 
ObjectDelete(Obj0003); 
ObjectDelete(Obj0004); 
ObjectDelete(Obj0005); 
ObjectDelete(Obj0006); 
ObjectDelete(Obj0007); 
ObjectDelete(Obj0008); 
ObjectDelete(Obj0009); 
ObjectDelete(Obj0010); 
ObjectDelete(Obj0011); 

ObjectDelete(ObjHead01);  
ObjectDelete(ObjHead02); 
ObjectDelete(ObjHead03); 
ObjectDelete(ObjHead04); 
ObjectDelete(ObjHead05); 
ObjectDelete(ObjHead06); 
ObjectDelete(ObjHead07); 
ObjectDelete(ObjHead08); 
ObjectDelete(ObjHead09); 

 
  }

//+------------------------------------------------------------------+
 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
   
 
/*


    
 
Comment(



"Bias_High    " , DoubleToStr(Bias_High,Digits) , "\n" ,  
"Bias_PrMidUp " , DoubleToStr(Bias_PrMidUp,Digits) , "\n" ,  
"Bias_PrMidDn " , DoubleToStr(Bias_PrMidDn,Digits) , "\n" ,  
"Bias_Low     " , DoubleToStr(Bias_Low,Digits) , "\n" ,  
"Bias_Close   " , DoubleToStr(Bias_Close,Digits) , "\n" ,   
"Bias_PrMid   " , DoubleToStr(Bias_PrMid,Digits) , "\n" ,  
"") ;   
         

ObjectDelete(Bias_ObjHead01);  
ObjectDelete(Bias_ObjHead02); 
ObjectDelete(Bias_ObjHead03); 
ObjectDelete(Bias_ObjHead04); 
ObjectDelete(Bias_ObjHead05); 
ObjectDelete(Bias_ObjHead06); 
ObjectDelete(Bias_ObjHead07); 
ObjectDelete(Bias_ObjHead08); 
ObjectDelete(Bias_ObjHead09); 

*/