//+------------------------------------------------------------------+ 
//|   TRO_OPEN_TARGETS                                                 | 
//|                                                                  | 
//|   Copyright  2014, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2014, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

extern bool   TURN_OFF         = false ;
extern bool   Show_Boxes       = true ;  
extern bool   Show_Labels      = true ; 

extern int    ShiftLabel  =  7 ;

extern int myShift  = 1 ;

extern int myTarget1  = 5 ;
extern int myTarget2  = 10 ;
extern int myTarget3  = 25 ;

extern int  iChartPeriod       = 1440;  

 

extern int    Line_Style    = STYLE_DOT ;
extern int    Line_Width    = 1 ;
 

extern color  Line_Color_Open     = Orange ;   
extern color  Line_Color_Target1  = Violet ;
extern color  Line_Color_Target2  = Chocolate ;
extern color  Line_Color_Target3  = Magenta ; 


string lbl[15], lbl2[15];
int n, j, i ;

string symbol,  tChartPeriod, tPeriod, ShortName , TAG , text;  

int    digits, period, win, BarShift ; 

double point ;



datetime DateTime ; 
   
double  a_Open,a_high, a_low , a_ATR , W1_ATR, VALUE , ATRThreshold ;      
double  a_Range, maxATR, minATR, p_High, p_Low, TARGET1 ; 

int FillAmt ;

//+------------------------------------------------------------------+

int init()
{
    period = Period() ;
    
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "otgt" ;
   ShortName    =  TAG+symbol+iChartPeriod+myShift  ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
   tPeriod = TimeFrameToString(iChartPeriod) ;
   FillAmt = 20 ;
  
   deinit();
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int LL = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, LL) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{



   if( TURN_OFF ) { return(0) ; }
   
n       = 10;
j       = 0 ;
    

DateTime  = iTime(symbol,iChartPeriod,0) ; 
a_Open    = iOpen(symbol,iChartPeriod,0) ;   

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(a_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, fFill(tPeriod + " Open"  , FillAmt) ) ;


DoTarget( myTarget1 , Line_Color_Target1 ) ;
DoTarget( myTarget2 , Line_Color_Target2 ) ;
DoTarget( myTarget3 , Line_Color_Target3 ) ;

return(0);
}
 

//+------------------------------------------------------------------+
 
void DoTarget(int dTarget , color dColor )
{


TARGET1   =  dTarget * point ;
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(TARGET1 + a_Open ,lbl[j], dColor , Line_Style , Line_Width, DateTime, fFill(tPeriod+ "["+myShift + "] Open + " + dTarget , FillAmt) ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(a_Open - TARGET1 ,lbl[j], dColor , Line_Style , Line_Width, DateTime, fFill(tPeriod+ "["+myShift + "] Open - " + dTarget , FillAmt) ) ;


}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string xtext)
{

         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
 
 
   if(Show_Labels)
   {         
      string Obj0002 = name+"linelbl" ;

      datetime LabelTime = Time[0]+Period()*60*ShiftLabel ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002, xtext , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl);
      } // if 
                 
   } // if   

   if(Show_Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}

//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

 
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

Comment(

 "\n" , 
"DailyOpen " , DoubleToStr(a_Open,Digits) , "\n" ,
"ATR " , DoubleToStr(a_ATR,Digits) , "\n" , 
"\n" , 
"DailyOpen + ATR " , DoubleToStr(a_Open + a_ATR,Digits) , "\n" , 
"a_high " , DoubleToStr(a_high,Digits) , "\n" ,
"a_low " , DoubleToStr(a_low,Digits) , "\n" ,
"DailyOpen - ATR " , DoubleToStr(a_Open - a_ATR,Digits) , "\n" , 
"") ; 


 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 
 */