//+------------------------------------------------------------------+ 
//|   TRO_TRADE_LINES_ohlm                                           | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

extern bool TURN_OFF    = false ;

extern bool   Show_D1     = true ; 
extern bool   Show_W1     = true ; 
extern bool   Show_MN     = true ; 

extern bool   Show_ShadeD1     = true ; 
extern bool   Show_ShadeW1     = true ; 
extern bool   Show_ShadeMN     = true ; 
extern bool   Show_ShadeATR    = true ; 

extern bool   Show_Boxes  = true ;
extern bool   Show_Labels = true ;
//extern int    ShiftLabel  =  20 ;


extern int myPeriod = 0 ;
extern int myShift  = 1 ;


extern int  iATRperiod       = 1440;  
 
 
extern int  iATRstart        = 2; 
extern int  iATRend          = 14;  

extern int  iPipsD1        = 100;  
extern int  iPipsW1        = 100; 
extern int  iPipsMN        = 100; 

extern int  iThresholdD1      = 20; 
extern int  iThresholdW1      = 10; 
extern int  iThresholdMN      = 10; 
extern int  iThresholdATR     = 10; 

extern int    Line_Style    = STYLE_DOT ;
extern int    Line_Width    = 1 ;

extern int    Line_Style_W1    = STYLE_SOLID ;
extern int    Line_Width_W1    = 2 ;

extern int    Line_Style_MN    = STYLE_SOLID ;
extern int    Line_Width_MN    = 2 ;

extern color  Color_Up             = Green ;
extern color  Color_Eq             = DimGray ; 
extern color  Color_Dn             = Red ; 
  
extern color  Line_Color_Hi        = Red ;
extern color  Line_Color_Mid       = Magenta ; 
extern color  Line_Color_Lo        = DodgerBlue ;
extern color  Line_Color_Open      = White ;
extern color  Line_Color_Close     = Yellow ;
extern color  Line_Color_ATR       = Chocolate ;
extern color  Line_Color_Pips      = HotPink ;
extern color  Line_Color_Pivot     = Purple ;


extern color colorBuyShade       = PowderBlue ;//MintCream PowderBlue
extern color colorShortShade     = MistyRose ;
extern color colorWaitBuyShade   = DarkGray  ;
extern color colorWaitShortShade = DarkGray ;

extern color colorATRHighShade   = Navy  ;
extern color colorATRLowShade    = Navy  ;


string lbl[99], lbl2[99];
int n, j, i ,a ;

string symbol, tChartPeriod, ShortName , TAG , text;  

int    digits, period, win, BarShift ; 

double point ;

double    HHprice, LLprice, TRIGGER, HHtrigger, LLtrigger, D1_Open, W1_Open, W1_High, W1_Low,  D1_pMid, D1_Close ;
datetime DateTime ; 
   
double  W1_Close,W1_pivot,D1_pivot, D1_high, D1_low , D1_ATR , W1_ATR, VALUE , D1Threshold , W1Threshold, ATRThreshold ;      
double  W1_Close1, W1_High1, W1_Low1, D1_Range , a_Range, maxATR, minATR, a_ATR ; 

int min, max ;

double  MN_Open, MN_High, MN_Low, MN_Close,MN_pivot,   MN_Close1, MN_High1, MNThreshold, MN_LoMN ; 

color cLineColor ;

int Chart_Scale  ,Bar_Width  ; 
//+------------------------------------------------------------------+
      
color fColor( double aa, double bb)
{
color rColor ;
 
    if ( aa > bb ) { rColor = Color_Up; } else {
    if ( aa < bb ) { rColor = Color_Dn;   } else {           
                     rColor = Color_Eq; } }
    
return ( rColor );
}
 
 
//+------------------------------------------------------------------+ 

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "troTL" ;
   ShortName    =  TAG+symbol+period+myShift  ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   D1Threshold  = iThresholdD1 * point ;
   W1Threshold  = iThresholdW1 * point ;
   MNThreshold  = iThresholdMN * point ;
   
   ATRThreshold = iThresholdATR * point ;     

  deinit() ;
   
  return(0);
  }
//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  }
//+------------------------------------------------------------------+
void ObDeleteObjectsByPrefix(string Prefix)
  {
   int LL = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, LL) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  } 
  
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
 
//+------------------------------------------------------------------+
int start()
{
   if( TURN_OFF ) { deinit(); return(0) ; }
   
   deinit();
 
   n       = 10;
   j       = 0 ;
 
   if(Show_D1) { DoD1() ;}   
   if(Show_W1) { DoW1() ;}  
   if(Show_MN) { DoMN() ;}  
   
   return(0);
}

//+------------------------------------------------------------------+

void DoD1()
{ 
maxATR = -1 ;
minATR = 9999999 ;
 
for( a = iATRstart; a <= iATRend; a++ )
{     
      
   a_ATR    = iATR(symbol,PERIOD_D1,a,0);  

   if( a_ATR > maxATR) { max = a; maxATR = a_ATR ; }
   if( a_ATR < minATR) { min = a; minATR = a_ATR ; }

} // for 
 
HHprice = iHigh(symbol,PERIOD_D1,myShift);  
LLprice = iLow(symbol,PERIOD_D1,myShift);  
D1_Open = iOpen(symbol,PERIOD_D1,0);  
D1_Close = iClose(symbol,PERIOD_D1,0);  
D1_high = iHigh(symbol,PERIOD_D1,0);
D1_low  = iLow(symbol,PERIOD_D1,0);

D1_pMid = ( HHprice + LLprice ) * 0.50 ;
D1_pMid = NormalizeDouble(D1_pMid,digits) ;

D1_pivot  = ( iClose(symbol,PERIOD_D1,myShift) + iHigh(symbol,PERIOD_D1,myShift) + iLow(symbol,PERIOD_D1,myShift) ) * 0.3333 ;

D1_Range = D1_high - D1_low ;

DateTime  = iTime(symbol,PERIOD_D1,myShift) ; 


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LLprice ,lbl[j], Line_Color_Lo , Line_Style , Line_Width, DateTime, "Daily Low["+myShift+"]" ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HHprice ,lbl[j], Line_Color_Hi , Line_Style , Line_Width, DateTime, "Daily High["+myShift+"]"   ) ;

cLineColor = fColor(D1_high,D1_low) ;

DateTime  = iTime(symbol,PERIOD_D1,0) ; 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, "Daily Open" ) ; 
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_low ,lbl[j], cLineColor , Line_Style , Line_Width, DateTime, "Daily Low" ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_high ,lbl[j], cLineColor , Line_Style , Line_Width, DateTime, "Daily High"   ) ;
 
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_pMid ,lbl[j], Line_Color_Mid , Line_Style , Line_Width, DateTime, "MidPoint["+myShift+"]"   ) ;


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(minATR + D1_Open ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,   "Daily Open + ATR("+min+")"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(maxATR + D1_Open ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Daily Open + ATR("+max+")"   ) ;


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Open - minATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Daily Open - ATR("+min+")"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Open - maxATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Daily Open - ATR("+max+")"    ) ;




j       = j + 1 ;
lbl[j]  = ShortName+j;
VALUE = D1_Open + ( iPipsD1 * point ) ;
drawLine(VALUE ,lbl[j], Line_Color_Pips , Line_Style , Line_Width, DateTime, "Daily Open + " + iPipsD1 +  " pips"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
VALUE = D1_Open - ( iPipsD1 * point ) ;
drawLine(VALUE ,lbl[j], Line_Color_Pips , Line_Style , Line_Width, DateTime, "Daily Open - " + iPipsD1 +  " pips"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_pivot ,lbl[j], Line_Color_Pivot , Line_Style , Line_Width, DateTime, "Daily Pivot"    ) ;
 
if(Show_ShadeD1 && D1_Range > D1Threshold)
{
    
        if (ObjectFind(ShortName+"89") != 0)
        ObjectCreate(ShortName+"89", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"89", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"89", OBJPROP_PRICE1, D1_low);
        ObjectSet(ShortName+"89", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"89", OBJPROP_PRICE2, D1_low+D1Threshold);
        ObjectSet(ShortName+"89", OBJPROP_COLOR, colorBuyShade);
        ObjectSet(ShortName+"89", OBJPROP_BACK, true);

  
        if (ObjectFind(ShortName+"80") != 0)
        ObjectCreate(ShortName+"80", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"80", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"80", OBJPROP_PRICE1, D1_high);
        ObjectSet(ShortName+"80", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"80", OBJPROP_PRICE2, D1_high-D1Threshold);
        ObjectSet(ShortName+"80", OBJPROP_COLOR, colorShortShade);
        ObjectSet(ShortName+"80", OBJPROP_BACK, true);
} // if(Show_Shade)

if(Show_ShadeATR)
{
        if (ObjectFind(ShortName+"91") != 0)
        ObjectCreate(ShortName+"91", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"91", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"91", OBJPROP_PRICE1, D1_Open + minATR);
        ObjectSet(ShortName+"91", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"91", OBJPROP_PRICE2, D1_Open + maxATR); // ATR + D1_low 
        ObjectSet(ShortName+"91", OBJPROP_COLOR, colorATRHighShade);
        ObjectSet(ShortName+"91", OBJPROP_BACK, true);         

        if (ObjectFind(ShortName+"92") != 0)
        ObjectCreate(ShortName+"92", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"92", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"92", OBJPROP_PRICE1, D1_Open - minATR);
        ObjectSet(ShortName+"92", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"92", OBJPROP_PRICE2, D1_Open - maxATR); // D1_high - ATR 
        ObjectSet(ShortName+"92", OBJPROP_COLOR, colorATRLowShade);
        ObjectSet(ShortName+"92", OBJPROP_BACK, true); 
        
        
        
            
} // if(Show_Shade)

}

//+------------------------------------------------------------------+

void DoW1()
{ 
maxATR = -1 ;
minATR = 9999999 ;
 

for( a = iATRstart; a <= iATRend; a++ )
{           
   a_ATR    = iATR(symbol,PERIOD_W1,a,0);  

   if( a_ATR > maxATR) { max = a; maxATR = a_ATR ; }
   if( a_ATR < minATR) { min = a; minATR = a_ATR ; }

} // for 


DateTime  = iTime(symbol,PERIOD_W1,0) ;  
BarShift  = iBarShift(symbol,PERIOD_W1,Time[0],true); 
W1_Open   = iOpen(symbol,PERIOD_W1,BarShift); 
W1_Close  = iClose(symbol,PERIOD_W1,myShift); 
W1_High   = iHigh(symbol,PERIOD_W1,myShift); 
W1_Low    = iLow(symbol,PERIOD_W1,myShift);  

W1_pivot  = ( iClose(symbol,PERIOD_W1,myShift) + iHigh(symbol,PERIOD_W1,myShift) + iLow(symbol,PERIOD_W1,myShift) ) * 0.3333 ;

cLineColor = fColor(W1_High,W1_Low) ; 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Open   ,lbl[j], Line_Color_Open , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Open"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Close   ,lbl[j], Line_Color_Close , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Close["+myShift+"]"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_High   ,lbl[j], cLineColor , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly High["+myShift+"]"     ) ;
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Low   ,lbl[j], cLineColor , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Low["+myShift+"]"     ) ;
   
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(minATR + W1_Open ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Weekly Open + ATR("+min+")"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(maxATR + W1_Open ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Weekly Open + ATR("+max+")"   ) ;


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Open - minATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Weekly Open - ATR("+min+")"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Open - maxATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Weekly Open - ATR("+max+")"    ) ;
 
   
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_pivot ,lbl[j], Line_Color_Pivot , Line_Style_W1 , Line_Width_W1, DateTime, "Weekly Pivot"    ) ;
  

if(Show_ShadeW1)
{
      
        if (ObjectFind(ShortName+"81") != 0)
        ObjectCreate(ShortName+"81", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"81", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"81", OBJPROP_PRICE1, W1_Open );
        ObjectSet(ShortName+"81", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"81", OBJPROP_PRICE2, W1_Open + W1Threshold  );
        ObjectSet(ShortName+"81", OBJPROP_COLOR, colorWaitBuyShade);
        ObjectSet(ShortName+"81", OBJPROP_BACK, true);

        
        if (ObjectFind(ShortName+"82") != 0)
        ObjectCreate(ShortName+"82", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"82", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"82", OBJPROP_PRICE1, W1_Open  );
        ObjectSet(ShortName+"82", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"82", OBJPROP_PRICE2, W1_Open - W1Threshold  );
        ObjectSet(ShortName+"82", OBJPROP_COLOR, colorWaitShortShade);
        ObjectSet(ShortName+"82", OBJPROP_BACK, true);   
} // if(Show_Shade) 
 
if(Show_ShadeATR)
{
        if (ObjectFind(ShortName+"61") != 0)
        ObjectCreate(ShortName+"61", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"61", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"61", OBJPROP_PRICE1, minATR + W1_Open);
        ObjectSet(ShortName+"61", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"61", OBJPROP_PRICE2, maxATR + W1_Open  ); // ATR + D1_low 
        ObjectSet(ShortName+"61", OBJPROP_COLOR, colorATRHighShade);
        ObjectSet(ShortName+"61", OBJPROP_BACK, true);         

        if (ObjectFind(ShortName+"62") != 0)
        ObjectCreate(ShortName+"62", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"62", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"62", OBJPROP_PRICE1, W1_Open - minATR);
        ObjectSet(ShortName+"62", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"62", OBJPROP_PRICE2, W1_Open - maxATR); // D1_high - ATR 
        ObjectSet(ShortName+"62", OBJPROP_COLOR, colorATRLowShade);
        ObjectSet(ShortName+"62", OBJPROP_BACK, true); 
            
} // if(Show_Shade) 
 
} 
//+------------------------------------------------------------------+  
void DoMN()
{   
  

maxATR = -1 ;
minATR = 9999999 ;
 

for( a = iATRstart; a <= iATRend; a++ )
{           
   a_ATR    = iATR(symbol,PERIOD_MN1,a,0);  

   if( a_ATR > maxATR) { max = a; maxATR = a_ATR ; }
   if( a_ATR < minATR) { min = a; minATR = a_ATR ; }

} // for 


DateTime  = iTime(symbol,PERIOD_MN1,0) ;  
BarShift  = iBarShift(symbol,PERIOD_MN1,Time[0],true); 
MN_Open   = iOpen(symbol,PERIOD_MN1,BarShift); 
MN_Close  = iClose(symbol,PERIOD_MN1,myShift); 
MN_High   = iHigh(symbol,PERIOD_MN1,myShift); 
MN_Low    = iLow(symbol,PERIOD_MN1,myShift); 
MN_pivot  = ( iClose(symbol,PERIOD_MN1,myShift) + iHigh(symbol,PERIOD_MN1,myShift) + iLow(symbol,PERIOD_MN1,myShift) ) * 0.3333 ;

cLineColor = fColor(MN_High,MN_Low) ; 

j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_Open   ,lbl[j], Line_Color_Open , Line_Style_MN  , Line_Width_MN , DateTime, "Monthly Open"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_Close   ,lbl[j], Line_Color_Close , Line_Style_MN  , Line_Width_MN , DateTime, "Monthly Close["+myShift+"]"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_High   ,lbl[j], cLineColor , Line_Style_MN  , Line_Width_MN , DateTime, "Monthly High["+myShift+"]"     ) ;
 
j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_Low   ,lbl[j], cLineColor , Line_Style_MN  , Line_Width_MN , DateTime, "Monthly Low["+myShift+"]"     ) ;
   
j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(minATR + MN_Open ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Monthly Open + ATR("+min+")"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(maxATR + MN_Open ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Monthly Open + ATR("+max+")"   ) ;


j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_Open - minATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Monthly Open - ATR("+min+")"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_Open - maxATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime,  "Monthly Open - ATR("+max+")"    ) ;
 
   
j       = j + 1 ;
lbl[j]  = ShortName+"MN"+j;
drawLine(MN_pivot ,lbl[j], Line_Color_Pivot , Line_Style_MN , Line_Width_MN, DateTime, "Monthly Pivot"    ) ;
  

if(Show_ShadeMN)
{
      
        if (ObjectFind(ShortName+"MN81") != 0)
        ObjectCreate(ShortName+"MN81", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"MN81", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"MN81", OBJPROP_PRICE1, MN_Open );
        ObjectSet(ShortName+"MN81", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"MN81", OBJPROP_PRICE2, MN_Open + MNThreshold  );
        ObjectSet(ShortName+"MN81", OBJPROP_COLOR, colorWaitBuyShade);
        ObjectSet(ShortName+"MN81", OBJPROP_BACK, true);

        
        if (ObjectFind(ShortName+"MN82") != 0)
        ObjectCreate(ShortName+"MN82", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"MN82", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"MN82", OBJPROP_PRICE1, MN_Open  );
        ObjectSet(ShortName+"MN82", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"MN82", OBJPROP_PRICE2, MN_Open - MNThreshold  );
        ObjectSet(ShortName+"MN82", OBJPROP_COLOR, colorWaitShortShade);
        ObjectSet(ShortName+"MN82", OBJPROP_BACK, true);   
} // if(Show_Shade) 
 
if(Show_ShadeATR)
{
        if (ObjectFind(ShortName+"MN61") != 0)
        ObjectCreate(ShortName+"MN61", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"MN61", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"MN61", OBJPROP_PRICE1, minATR + MN_Open);
        ObjectSet(ShortName+"MN61", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"MN61", OBJPROP_PRICE2, maxATR + MN_Open  ); // ATR + D1_low 
        ObjectSet(ShortName+"MN61", OBJPROP_COLOR, colorATRHighShade);
        ObjectSet(ShortName+"MN61", OBJPROP_BACK, true);         

        if (ObjectFind(ShortName+"MN62") != 0)
        ObjectCreate(ShortName+"MN62", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"MN62", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"MN62", OBJPROP_PRICE1, MN_Open - minATR);
        ObjectSet(ShortName+"MN62", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"MN62", OBJPROP_PRICE2, MN_Open - maxATR); // D1_high - ATR 
        ObjectSet(ShortName+"MN62", OBJPROP_COLOR, colorATRLowShade);
        ObjectSet(ShortName+"MN62", OBJPROP_BACK, true); 
            
} // if(Show_Shade) 
 
  
} 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string xtext)
{
     
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }

     //Determine the current chart scale (chart scale number should be 0-5)
  Chart_Scale = ChartScaleGet();
  
  //Set bar widths             
        if(Chart_Scale == 0) {Bar_Width = 120;}
  else {if(Chart_Scale == 1) {Bar_Width = 60;}      
  else {if(Chart_Scale == 2) {Bar_Width = 30;}
  else {if(Chart_Scale == 3) {Bar_Width = 15;}
  else {if(Chart_Scale == 4) {Bar_Width = 8;}
  else {Bar_Width = 4;} }}}}
 
     datetime LabelTime = Time[0]+Period()*60*Bar_Width ; // Time[WindowFirstVisibleBar()/2]; // Time[0]+Period()*60*ShiftLabel ;   
 
   if(Show_Labels)
   {         
      string Obj0002 = name+"linelbl" ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002, fFill(xtext,20) , 8, "Terminal", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl); // Time[ShiftLabel]
      } // if 
                 
   } // if   

   if(Show_Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}
  
 
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

Comment(

 "\n" , 
"DailyOpen " , DoubleToStr(D1_Open,Digits) , "\n" ,
"ATR " , DoubleToStr(D1_ATR,Digits) , "\n" , 
"\n" , 
"DailyOpen + ATR " , DoubleToStr(D1_Open + D1_ATR,Digits) , "\n" , 
"D1_high " , DoubleToStr(D1_high,Digits) , "\n" ,
"D1_low " , DoubleToStr(D1_low,Digits) , "\n" ,
"DailyOpen - ATR " , DoubleToStr(D1_Open - D1_ATR,Digits) , "\n" , 
"") ; 


 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 
 */