//+------------------------------------------------------------------+ 
//|   TRO_TRAININGWHEELS_IND2                                        | 
//|                                                                  | 
//|   Copyright  2016, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1

//---- indicator parameters  
extern bool TURN_OFF    = false ;



extern int corner         = 3;
extern int price_x_offset = 200 ; 
extern int price_y_offset = 10 ; 

extern string myFont          = "Terminal" ;
extern int   myFontSize       = 16;

extern string Sell_Message   = "Short Bias " ;
extern string Wait_Message   = "WAIT " ;
extern string Buy_Message    = "Long Bias " ;
 

extern color Buy_color     = Lime;
extern color Wait_color    = DimGray;
extern color Sell_color    = Red;
 


int win            = 0;

string tMessage , oldmsg = "" ; 

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
double point;

datetime Trigger ;

int OldBars = -1 , limit ;

color tColor = Yellow ;
 
color ClOpColor ;

string tObjName03 = "TROTWprmid"  ; 

double MA_Cur, MA_Prev,  price;

int       MAPeriod         = 5;
int       MAType           = 1;  
  
//+------------------------------------------------------------------+ 
int init() 
{ 
 //  if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }         
   
   period       =  Period() ;
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
     
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   tShortName = "TROtwprmid"+ symbol + tChartPeriod  ;
   deinit() ;
   
   return(0); 
} 
//+------------------------------------------------------------------+ 

int deinit() 
{ 


   ObjectDelete("troprmid31");
 
   ObjectDelete(tObjName03);       
      
   TRO() ;
    
   return(0);   
}  
 
//+------------------------------------------------------------------+ 
int start() 
{ 
   if( TURN_OFF ) { deinit(); return(0) ; }
   
   ClOpColor = Wait_color ;

   price = iClose(symbol,period,0);
     
   MA_Cur  = iMA(symbol,period,MAPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MA_Prev = iMA(symbol,period,MAPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   
   while(true)
   {   

      if( MA_Cur > MA_Prev && price > MA_Cur) { tMessage = Buy_Message ;  ClOpColor = Buy_color ; break ; } // && open0 > mid1

      if( MA_Cur < MA_Prev && price < MA_Cur ) { tMessage = Sell_Message ; ClOpColor = Sell_color ; break ; } // && open0 < mid1 
         
      tMessage    = Wait_Message   ; 
      ClOpColor   = Wait_color ; 
      
      break;
   
   } // while
     
/*


      if( close2 < mid2 && close1 > mid2  ) { tMessage = Buy_Message ;  ClOpColor = Buy_color ; break ; } // && open0 > mid1

      if( close2 > mid2 && close1 < mid2 ) { tMessage = Sell_Message ; ClOpColor = Sell_color ; break ; } // && open0 < mid1 
    
*/         


   tMessage = tChartPeriod + " IND2 " + tMessage ;

//+------------------------------------------------------------------+  
                    
   ObjectCreate("troprmid31", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("troprmid31",tMessage, myFontSize , myFont, ClOpColor );
   ObjectSet("troprmid31", OBJPROP_CORNER, corner);
   ObjectSet("troprmid31", OBJPROP_XDISTANCE, price_x_offset); 
   ObjectSet("troprmid31", OBJPROP_YDISTANCE, price_y_offset); 

 
   WindowRedraw();   
   
   return(0);
}

//+------------------------------------------------------------------+
 

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}

//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
 
/*
 
if( C < D1_low  && open > D1_low  )
{
   Comment(
   "period  " , period, "\n" ,
   "D0_high:" +  DoubleToStr( D0_high , Digits) , "\n" ,
   "D0_low:" +  DoubleToStr( D0_low , Digits) , "\n" ,    
   "D1_high:" +  DoubleToStr( D1_high , Digits) , "\n" ,
   "D1_low:" +  DoubleToStr( D1_low , Digits) , "\n" ,
   "open:" +  DoubleToStr(open , Digits) , "\n" ,
   "high:" +  DoubleToStr( high , Digits) , "\n" ,
   "low:" +  DoubleToStr( low , Digits) , "\n" ,
      
   "C:" +  DoubleToStr( C , Digits) , "\n" ,
   "HO:" +  DoubleToStr( HO , Digits) , "\n" ,
   "LO:" +  DoubleToStr( LO , Digits) , "\n" ,
   "nHO  " , nHO, "\n" ,   
   "nLO  " , nLO, "\n" ,  
   
   "clHO:" +  DoubleToStr( clHO , Digits) , "\n" ,
   "clLO:" +     DoubleToStr( clLO , Digits) , "\n" ,
   "tMessage  " , tMessage, "\n" ,
   "limit " , limit, "\n" ,
   
   "") ;   
}
 
*/