//+------------------------------------------------------------------+ 
//|   TRO_Uncertainty                                                | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/"
 
//+------------------------------------------------------------------+
 

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 5
#property indicator_color1 Lime
#property indicator_color2 OrangeRed

#property indicator_minimum 0
#property indicator_maximum 2

extern bool   UNC_Sound_Alert    = false ;
extern bool   UNC_Comment        = false ;
  

extern color UNC_BarColorUp   = Lime;
extern color UNC_BarColorDown = OrangeRed;
extern color UNC_BarColorFlat = DimGray;
//extern color TextColor    = White;

int UNC_BarWidth = 0;
int myWingding = 110;// 112

double buf1_up[];
double buf1_down[];
double buf1_flat[]; 

//---- indicator parameters
  int FastEMA=2;
  int SlowEMA=3;
  int SignalSMA=9;
//---- indicator buffers
double     MBuffer[];
double     SBuffer[];

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
datetime Trigger ;

//---- variables

string tTrade = "" ;   
color tColor    = White;
string tObjName01   ;
int      corner;
int      window; 
string   shortName;
int      win ;  

bool sFirst;



int YourAccountNumber, maxi ;


double point, pos = 0.5 ;

 

bool FILLED = false;



double    D1_Open, D1_Close, D1_high, D1_low, D1_range, D1_pivot, D1_ClOp    ; 
 
 

//+------------------------------------------------------------------+
int init()
  {

  sFirst = true ;

   period       =  Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }    
   
   shortName  = "Uncertainty " + tChartPeriod ;
   tObjName01 = shortName  ;


   IndicatorShortName(shortName);  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,UNC_BarWidth,UNC_BarColorUp);
   SetIndexArrow(0,myWingding);
   SetIndexBuffer(0,buf1_up);

   
   SetIndexStyle(1,DRAW_ARROW,0,UNC_BarWidth,UNC_BarColorDown);
   SetIndexArrow(1,myWingding);
   SetIndexBuffer(1,buf1_down);
   
   SetIndexStyle(2,DRAW_NONE) ;
   SetIndexBuffer(2,MBuffer);
   
   SetIndexStyle(3,DRAW_NONE) ;   
   SetIndexBuffer(3,SBuffer);   

   
   SetIndexStyle(4,DRAW_ARROW,0,UNC_BarWidth,UNC_BarColorFlat);
   SetIndexArrow(4,myWingding);
   SetIndexBuffer(4,buf1_flat);
      
   IndicatorDigits(0);
   
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
 
  Comment("") ;
   return(0);
  }
    
//+------------------------------------------------------------------+
int start()
  {
  
  
  
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   if(FILLED) { limit=Bars-counted_bars; }
   else { limit = Bars ; }
   


   for(int i=0; i<limit; i++)
   {
      buf1_down[i]=EMPTY_VALUE;
      buf1_up[i]  =EMPTY_VALUE; 
      buf1_flat[i]=EMPTY_VALUE;                
      MBuffer[i]=iMA(symbol,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(symbol,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   }
   
    

  for( i=0; i<limit; i++)
  {
      if (MBuffer[i] < 0 && Close[i] < iMA(symbol,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i) ) { buf1_down[i] = pos ;    }
      else 
      if (MBuffer[i] > 0 && Close[i] > iMA(symbol,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i) ) { buf1_up[i]   = pos ;    }
      else  { buf1_flat[i]   = pos ;    }
  }

   if( i > 100 ) { FILLED = true ; }

  if (  Trigger != Time[0] && UNC_Sound_Alert ) // Trigger != Time[0] && 
  {
        if( buf1_up[1]   == pos && buf1_up[2]   != pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Uncertainty BUY!  "+ DoubleToStr(Close[0] ,digits)); }
        if( buf1_down[1] == pos && buf1_down[2] != pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Uncertainty SELL SHORT! "+ DoubleToStr(Close[0] ,digits)); }     
  }

if(UNC_Comment)
{
D1_Open  = iOpen(symbol,PERIOD_D1,0);  
D1_Close = iClose(symbol,PERIOD_D1,0);  
D1_high  = iHigh(symbol,PERIOD_D1,0);
D1_low   = iLow(symbol,PERIOD_D1,0);
D1_pivot = ( D1_Close + D1_high + D1_low ) / 3.0 ; 
D1_range = ( D1_high - D1_low ) / point ;
D1_ClOp  = ( D1_Close - D1_Open ) / point ;


Comment(

 "\n" , "Daily " ,  
"O=" , DoubleToStr(D1_Open,Digits) , " " ,
"H=" , DoubleToStr(D1_high,Digits) , " " ,
"L=" , DoubleToStr(D1_low,Digits) , " " ,
"C=" , DoubleToStr(D1_Close,Digits) , " " ,
"P=" , DoubleToStr(D1_pivot,Digits) , " " ,
"R=" , DoubleToStr(D1_range,0) , " " ,
"D=" , DoubleToStr(D1_ClOp,0) , " " ,

"") ; 
} // if(UNC_Comment)


return(0);
}
  
//+------------------------------------------------------------------+
 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+
/*

Comment(

"pair " , symbol , "\n" , 
"MBuffer[0] " , DoubleToStr(MBuffer[0],6) , "\n" ,
"SBuffer[0] " , DoubleToStr(SBuffer[0],6) , "\n" ,

"buf1_up[0] " , DoubleToStr(buf1_up[0],Digits) , "\n" ,
"buf1_up[1] " , DoubleToStr(buf1_up[1],Digits) , "\n" ,
"buf1_up[2] " , DoubleToStr(buf1_up[1],Digits) , "\n" ,
"buf1_down[0] " , DoubleToStr(buf1_down[0],Digits) , "\n" ,
"buf1_down[1] " , DoubleToStr(buf1_down[1],Digits) , "\n" ,
"buf1_down[2] " , DoubleToStr(buf1_down[1],Digits) , "\n" ,
"") ; 

*/