//+------------------------------------------------------------------+
//|             TRO_WICK_NUMBERS                                     |
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 4
 
extern bool TURN_OFF          = false ;
 
extern  bool Show_Help        = false ;
extern color colorHelp        = Orange ; 
 
extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 12 ; 
extern color  myColor      = Blue ;
extern color  myZcolor     = Magenta ;

extern int myStart = 0  ;
extern int myBars  = 0 ;
extern int mySpace  = 1 ;
 
//---- buffers

double     H_Buffer[];
double     L_Buffer[];


string SHORTNAME ;
string totOT1 , totOT2, totOT3 ;

string symbol, tChartPeriod,  tShortName ;    
int    i, digits, period, digits2  ; 


double point , open,close,high, low;

		
   double X01,X03, X04  ;
   double X02  ; 

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011,Obj0012,Obj0013,Obj0014,Obj0015,Obj0016,Obj0017;  

string aHelp[20];

double HO[], CO[], OL[], OC[] ;

int limit, zSize;   

bool RED, GREEN; 
 
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   
 
   SetIndexStyle(0,DRAW_NONE);  
   SetIndexStyle(1,DRAW_NONE); 
   SetIndexStyle(2,DRAW_NONE); 
   SetIndexStyle(3,DRAW_NONE); 
   
   SetIndexBuffer(0,HO);
   SetIndexBuffer(1,CO);
   SetIndexBuffer(2,OL); 
   SetIndexBuffer(3,OC); 
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0); 
   SetIndexEmptyValue(3,0.0);    
   
   period       = Period() ;   
   symbol       = Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
        
   tChartPeriod =  TimeFrameToString(period) ;
 
     
   SHORTNAME = "Wicknum" ;
   
   return(0);
  } 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int LL = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, LL) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix(SHORTNAME);     
   TRO();
      
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{ 
   if( TURN_OFF ) { deinit(); return(0) ; }
   
   if(Show_Help) { DoHelp () ; } else { deinit() ; }   
 
   if(myBars == 0) {   limit    = WindowBarsPerChart() ;  } else { limit = myBars ; } 
 
   for( i=myStart; i<limit; i++)
   {   
 
      open      = iOpen(symbol,period,i) ; 
      close     = iClose(symbol,period,i) ;
      high      = iHigh(symbol,period,i) ; 
      low       = iLow(symbol,period,i) ; 
 
         HO[i] = (high - open) / point ;
         CO[i] = (close - open) / point ;
         DoPlotG( i, HO[i], CO[i] );
 
         OL[i] = (open - low) / point ;
         OC[i] = (open - close) / point ;
         DoPlotR( i, OL[i], OC[i] );
             
   } // for i
   
   return(0);
}

//+------------------------------------------------------------------+ 

void DoPlotG( int p , double pNum, double pNum2 )
{

  string sSHORTNAME = SHORTNAME + p ;
  string sNum    = DoubleToStr(pNum , 0) ;
  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],High[p]+ 10*point*mySpace); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, Lime );   

      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],High[p]+ 10*point*mySpace);
      }

  sSHORTNAME = SHORTNAME + p + "G" ;
  sNum    = DoubleToStr(pNum2 , 0) ;
  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],High[p]+ 5*point*mySpace); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, Green );   

      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],High[p]+ 5*point*mySpace);
      }
 
}

//+------------------------------------------------------------------+ 

void DoPlotR( int p , double pNum, double pNum2 )
{

  string sSHORTNAME = SHORTNAME+ "Z" + p ;
  string sNum    = DoubleToStr(pNum , 0) ;
 
   
  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],Low[p]- 10*point*mySpace); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, Red );   
          ObjectSet(sSHORTNAME,OBJPROP_BACK,false) ;
      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],Low[p]- 10*point*mySpace);
      }

  sSHORTNAME = SHORTNAME+ "R" + p ;
  sNum    = DoubleToStr(pNum2 , 0) ;
 
   
  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],Low[p]- 5*point*mySpace); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, Crimson );   
          ObjectSet(sSHORTNAME,OBJPROP_BACK,false) ;
      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],Low[p]- 5*point*mySpace);
      } 
}

//+------------------------------------------------------------------+
 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
  
//+------------------------------------------------------------------+  

void DoHelp()
{



aHelp[0] = "TRO_WICK_NUMBERS" ;
aHelp[1] = " " ;
aHelp[2] = "UPPER GREEN NUMBER: HIGH - OPEN" ;
aHelp[3] = "LOWER GREEN NUMBER: CLOSE - OPEN" ;
aHelp[4] = " " ;
aHelp[5] = "UPPER RED NUMBER: OPEN - CLOSE " ;
aHelp[6] = "LOWER RED NUMBER: OPEN - LOW  " ;
aHelp[7] = "  " ;
aHelp[8] = "  " ;  
aHelp[9]  = " " ;
aHelp[10] = "  " ;
aHelp[11] = "  " ;
aHelp[12] = " " ;
aHelp[13] = "  " ;
aHelp[14] = "  " ;
aHelp[15] = " " ;
aHelp[16] = " " ;
aHelp[17] = " " ;
aHelp[18] = " " ;
aHelp[19] = " " ;

ArrayResize(aHelp,20);

for( int h = 0 ; h < 20 ; h++ )
{
   drawComment(SHORTNAME+"aHelp"+h,aHelp[h] , 10, 120 + 20*h , colorHelp  ) ;
} 

}

//+------------------------------------------------------------------+  
 
void drawComment(string tLabel,string name, int xPos, int yPos ,color Color  )
{

ObjectCreate(tLabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(tLabel, OBJPROP_CORNER, 0 );
ObjectSet(tLabel,OBJPROP_XDISTANCE,xPos);
ObjectSet(tLabel,OBJPROP_YDISTANCE,yPos);
ObjectSetText(tLabel,name,12,"Courier New",Color); 
} 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+



/*

if(i==0)
{
Comment( 
"open = ", DoubleToStr(open , digits), "\n",        
"high = ", DoubleToStr(high , digits), "\n",  
"low = ", DoubleToStr(low , digits), "\n",  
"close = ", DoubleToStr(close , digits), "\n",        
"HO[i] = ", DoubleToStr(HO[i] , digits), "\n",  
"CO[i] = ", DoubleToStr(CO[i] , digits), "\n",  
"OL[i] = ", DoubleToStr(OL[i] , digits), "\n",  
"OC[i] = ", DoubleToStr(OC[i] , digits), "\n",
"") ; 
}


      GREEN = close >= open ;
      RED   = !GREEN ;
       
      if(GREEN)
      {
         HO[i] = (high - open) / point ;
         CO[i] = (close - open) / point ;
         OL[i] = 0 ;
         OC[i] = 0 ;
         DoPlotG( i, HO[i], CO[i] );
 
      } 
      else
      {
         HO[i] = 0 ;
         CO[i] = 0 ;
         OL[i] = (open - low) / point ;
         OC[i] = (open - close) / point ;
         DoPlotR( i, OL[i], OC[i] );
       
      }  


*/