//+------------------------------------------------------------------+ 
//|   TRO_WIPE_OUT                                                   | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern int myChartX   = 10 ;
extern int myChartY   = 100 ;
extern int myCorner   = 1 ;
extern string myFont  = "Courier" ;
extern int myFontSize = 12 ;
 


extern bool  Show_Lines = true ;
extern int    Line_Style    = STYLE_DASH ;
extern int    Line_Width    = 1 ;

extern double myPrice       = 0 ;
extern int myPercent     = 100 ;
extern int myBarsBack    = 0 ;

extern color colorHead  = Orange ;

double Hi, Li, C;

double prev_high, prev_low, prev_close, D, p, value ;
int h  ;
string lbl[15], lbl2[15];
int n, j, i, shift, stop, nHH, nLL  ;

color pColor = Blue ;

string symbol, tChartPeriod, ShortName, TAG ;  

int    digits, period, win ; 
double    H1L0, L1H0 ;

double point,  open, high, low, close, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange  ;  
double xMax = - 1,  xMin = 9999999999999, xDiff, xClose, xHigh, xLow, xRunUp, xRunDn, xPain ;
double High0, Low0, Open0,  Close0, Open1,High1, Low1, Close1, price, LgWipeOut, ShWipeOut, tickvalue   ;  
 
int myPeriod = 0 ;      
int x001, x002, x003, x004, x005, x006, x007 ; 

      
//+------------------------------------------------------------------+

int init()
  {
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  
      
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "WipeOut" ;
   ShortName    =  TAG+symbol+period+myPeriod ;
   win          =  0 ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } 
     
if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 80 ; 
   x004 = 200;
   x005 = 00 ;
   x006 = 00 ;  
   x007 = 00 ;    
}
else
{
   x001 = 10 ;
   x002 = 250 ;
   x003 = 220 ; 
   x004 = 10 ;
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;     
}    
   
   
   return(0);
}

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int ll = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, ll) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
    
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{

RefreshRates();    

tickvalue = 1 / ( MarketInfo(symbol,MODE_TICKVALUE) * 0.10 );  

n       = 10;
 
j       = 0 ;

lbl[j]  = ShortName+j;
lbl2[j] = "TRO WipeOut(" + myPercent + "%) [" + myBarsBack + "]" ;
DoShowHD(j, colorHead);

DoWork( myPercent ) ;

j = j + 1 ; 
 
lbl[j]  = ShortName+j;
lbl2[j] = DoubleToStr(price,digits) + " " ;
DoShow(j, colorHead); 
 


if( Show_Lines )
{

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(ShWipeOut ,lbl[j], Red , Line_Style ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LgWipeOut ,lbl[j], Lime , Line_Style ) ;


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(price ,lbl[j], colorHead , Line_Style ) ;

if( myPrice == 0 ) 
{

string tPIVOT1 ="trowo" ;
  if (ObjectFind(tPIVOT1) != 0)
      {
          ObjectCreate(tPIVOT1,OBJ_ARROW,0,Time[myBarsBack],LgWipeOut);
          ObjectSet(tPIVOT1,OBJPROP_ARROWCODE,217);
          ObjectSet(tPIVOT1,OBJPROP_COLOR,colorHead);  
      } 
      else
      {
         ObjectMove(tPIVOT1,0,Time[myBarsBack],LgWipeOut);
      }

} // if if( myPrice == 0 ) 


} // if( Show_Lines )

//---------


   return(0);
  }
//+------------------------------------------------------------------+
  
void DoShowHD( int u, color dscolor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE,x001+  myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dscolor);


n = n+20;

return;

} 
//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

if( u > 0 )
{

string rlabel = lbl[u]+"red"  ;
string sLgWipeOut = DoubleToStr(LgWipeOut,digits) ;
ObjectCreate(rlabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(rlabel, OBJPROP_CORNER, myCorner );
ObjectSet(rlabel,OBJPROP_XDISTANCE, 80+myChartX);
ObjectSet(rlabel,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(rlabel,""+sLgWipeOut,myFontSize,myFont,Lime);

string glabel = lbl[u] + "green" ;
string sShWipeOut = DoubleToStr(ShWipeOut,digits) ;
ObjectCreate(glabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(glabel, OBJPROP_CORNER, myCorner );
ObjectSet(glabel,OBJPROP_XDISTANCE, 150+myChartX);
ObjectSet(glabel,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(glabel,""+sShWipeOut,myFontSize,myFont,Red);
 
}

n = n+20;
 
  }

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = Lime ; } else {
if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}  
  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, myFontSize, myFont , EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
          
         }
 

}

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
void DoWork( int wPercent )
{


  
if( myPrice == 0 ) { price = iOpen(NULL,0,myBarsBack) ; } else { price = myPrice ; } 
 
LgWipeOut = price - (  ( 100 / myPercent ) * point * 100 ) / tickvalue;  
ShWipeOut = price + (  ( 100 / myPercent ) * point * 100 ) / tickvalue ;  

}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
} 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}  
//+------------------------------------------------------------------+
/*

Comment(

"ind_bufferOp[0]" , ind_bufferOp[0] , "\n" ,   
"Open0 " , DoubleToStr(Open0,Digits) , "\n" ,  
"Close0 " , DoubleToStr(Close0,Digits) , "\n" ,   
"Open1 " , DoubleToStr(Open1,Digits) , "\n" ,  
"Close1 " , DoubleToStr(Close1,Digits) , "\n" ,   

"") ; 
*/