//+------------------------------------------------------------------+ 
//|   _TRO_COMPASS_STR                                               | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+
//|                                                Complex_pairs.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//|                 http://forum.alpari-idc.ru/viewtopic.php?t=46916 |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings 
#property indicator_separate_window
#property indicator_buffers 0
//#property indicator_minimum 0
//#property indicator_maximum 1



//---- indicator parameters  
 

//extern int win = 1;
extern int price_x_offset= 0 ;//250
extern int price_y_offset= -160 ;//-160

extern bool Show_arrow = true ;
extern bool Show_value = true ;
extern int  myDecimals = 2 ;

extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 30 ;
extern int    myArrowSize  = 40 ;
extern int    myDigitSize  = 20 ;
extern int    xStart       = -600 ;
extern int    xOffSet      = 100 ;

//extern string Ind_Name_1 ="iMA";
extern color  myIndColor = DarkGray ;

//extern double iParm1 = 0;
//extern double iParm2 = 0;


/*

PARM6 FOR MA = 

PRICE_CLOSE	0	Close price_
PRICE_OPEN	1	Open price_
PRICE_HIGH	2	High price_
PRICE_LOW	3	Low price_
PRICE_MEDIAN	4	Median price, (high+low)/2.
PRICE_TYPICAL	5	Typical price, (high+low+close)/3.
PRICE_WEIGHTED	6	Weighted close price, (high+low+close+close)/4.


PARM3 FOR MA = 
MODE_SMA	0	Simple moving average,
MODE_EMA	1	Exponential moving average,
MODE_SMMA	2	Smoothed moving average,
MODE_LWMA	3	Linear weighted moving average.



extern double iParm3 = 5;
extern double iParm4 = 0;
extern double iParm5 = 1;  
extern double iParm6 = 0;
extern double iParm7 = 0;
extern double iParm8 = 0;
*/

extern color N_color  = Lime;
extern color NE_color = Lime;
extern color E_color  = Yellow;
extern color SE_color = Red;
extern color S_color  = Red;


//---- indicator buffers 



// int   Chart_Period    = PERIOD_H1;


//---- buffers






string Arrow12 = ""; // 12 oclock
string Arrow2  = "";  // 2 oclock
string Arrow3  = "";  // 3 oclock
string Arrow5  = "";  // 5 oclock
string Arrow6  = "";  // 6 oclock


string tObjName01   ;
string tObjName02   ;
string tObjName03   ;
string tObjName04 , tObjName05, IndHead ;

double open    ;  
double close    ; 
double close1   ;  
double high    ;    
double high1    ;   
double low     ;    
double low1     ; 

double mid      ; 
double mid1    ; 


double pCount   ;

int   HighDir, LowDir, MidDir, Mid1Dir, CloseDir, ClOpDir ;
color HighColor, LowColor, MidColor, Mid1Color, CloseColor ;

string PriceDir   ;

string tPeriod   ; 

double cVal, pVal ;

//+------------------------------------------------------------------+
int      totalLabels;
string   labelNames;
int      corner;
int      window; 
string   shortName ;
int      win ;
//+------------------------------------------------------------------+
   double OPEN,HIGH,LOW,CLOSE;
//   int Price=6;
//   int Mode=3;
//   int per1,per2;
//   double prev,current;


double     ExtBuffer0[2];
double     ExtBuffer1[];
double     ExtBuffer2[]; 
    
//---- parameters
// for monthly
int mn_per=50;
int mn_fast=1;
// for weekly
int w_per=50;
int w_fast=1;
// for daily 
int d_per=50;
int d_fast=1;
// for H4      
int h4_per=50;    
int h4_fast=1;
// for H1
int h1_per=50;
int h1_fast=1;
// for M30
int m30_per=50;
int m30_fast=1;
// for M15
int m15_per=50;
int m15_fast=1;
// for M5
int m5_per=50;
int m5_fast=1;
// for M1
int m1_per=50;
int m1_fast=1;

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

color fColor( double i)
{
color rColor ;

    if ( i >= 0 ) rColor = N_color  ; else {  
                  rColor = S_color ; }  

return ( rColor );
}
//+------------------------------------------------------------------+

int fDirection( double xaEMA, double xaEMA1)
{
int rDir ;

if( xaEMA >= xaEMA1 ) {  rDir = 2;  }
else  { rDir = -2;  }   

return ( rDir );
}

 

//+------------------------------------------------------------------+


string fCompass( double i )
{
string rCompass ;

    if ( i == 2 ) rCompass = Arrow2  ; else {
    if ( i == 1 ) rCompass = Arrow2  ; else {
    if ( i == -1 ) rCompass = Arrow5  ; else {
    if ( i == -2 ) rCompass = Arrow5  ; else {      
    rCompass = Arrow3 ; } } } }
    
return ( rCompass );
}


//+------------------------------------------------------------------+

int init() 
  { 
   shortName  = MakeUniqueName("STR ","");
   labelNames = shortName;
   IndicatorShortName(shortName);
   totalLabels     = 0;

   return(0); 
  } 

int deinit() 
{ 
   while (totalLabels>0) { ObjectDelete(StringConcatenate(labelNames,totalLabels)); totalLabels--;}
  
DoDelObj( PERIOD_M1 ) ;
DoDelObj( PERIOD_M5 ) ;
DoDelObj( PERIOD_M15 ) ;  
DoDelObj( PERIOD_H1 ) ;
DoDelObj( PERIOD_H4 ) ;
DoDelObj( PERIOD_D1 ) ;
DoDelObj( PERIOD_W1 ) ;
DoDelObj( PERIOD_MN1 ) ;

return(0);   
}  

//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 


int xStart2 = xStart + xOffSet ;
int xStart3 = xStart + xOffSet*2 ;
int xStart4 = xStart + xOffSet*3 ;
int xStart5 = xStart + xOffSet*4 ;
int xStart6 = xStart + xOffSet*5 ;
int xStart7 = xStart + xOffSet*6 ;
int xStart8 = xStart + xOffSet*7 ;

win =    WindowFind(shortName);

bool sFirst = true ;

if ( sFirst ) {
sFirst = false ;
ObjectDelete(tObjName04);

ObjectsDeleteAll( win, 21);
ObjectsDeleteAll( win, 22);
ObjectsDeleteAll( win, 23);
}

IndHead =  "STR "  ;

DoHead(IndHead );

DoWork( PERIOD_M1 ) ;
DoShow( PERIOD_M1, xStart ) ;

DoWork( PERIOD_M5 ) ;
DoShow( PERIOD_M5, xStart2 ) ;

DoWork( PERIOD_M15 ) ;
DoShow( PERIOD_M15, xStart3 ) ;                      

DoWork( PERIOD_H1 ) ;
DoShow( PERIOD_H1, xStart4 ) ;

DoWork( PERIOD_H4 ) ;
DoShow( PERIOD_H4, xStart5 ) ;

DoWork( PERIOD_D1 ) ;
DoShow( PERIOD_D1, xStart6 ) ;

DoWork( PERIOD_W1 ) ;
DoShow( PERIOD_W1, xStart7 ) ;

DoWork( PERIOD_MN1 ) ;
DoShow( PERIOD_MN1, xStart8 ) ;

WindowRedraw();    
 


   return(0); 
} 
 
 
//+------------------------------------------------------------------+ 

void DoWork( int myPeriod  )  
{

   int Price=6;
   int Mode=3;
   int per1,per2;
//   double prev,current;
     
   switch(myPeriod )
     {
      case 1:     per1=m1_per; per2=m1_fast; break;
      case 5:     per1=m5_per; per2=m5_fast; break;
      case 15:    per1=m15_per;per2=m15_fast; break;
      case 30:    per1=m30_per;per2=m30_fast; break;
      case 60:    per1=h1_per; per2=h1_fast; break;
      case 240:   per1=h4_per; per2=h4_fast; break;
      case 1440:  per1=d_per;  per2=d_fast; break;
      case 10080: per1=w_per;  per2=w_fast; break;
      case 43200: per1=mn_per; per2=mn_fast; break;
     }
  
   for(int i=0; i<2; i++)
     {

        if (Symbol()=="EURUSD")
        {
         OPEN=EUR(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-USD(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=EUR(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-USD(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=EUR(Mode,PRICE_LOW,i,per1,per2, myPeriod )-USD(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=EUR(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-USD(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="EURGBP")
        {
         OPEN=EUR(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-GBP(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=EUR(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-GBP(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=EUR(Mode,PRICE_LOW,i,per1,per2, myPeriod )-GBP(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=EUR(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-GBP(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="EURCHF")
        {
         OPEN=EUR(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-CHF(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=EUR(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-CHF(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=EUR(Mode,PRICE_LOW,i,per1,per2, myPeriod )-CHF(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=EUR(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-CHF(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="EURJPY")
        {
         OPEN=EUR(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-JPY(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=EUR(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-JPY(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=EUR(Mode,PRICE_LOW,i,per1,per2, myPeriod )-JPY(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=EUR(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-JPY(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="GBPUSD")
        {
         OPEN=GBP(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-USD(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=GBP(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-USD(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=GBP(Mode,PRICE_LOW,i,per1,per2, myPeriod )-USD(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=GBP(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-USD(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="GBPCHF")
        {
         OPEN=GBP(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-CHF(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=GBP(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-CHF(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=GBP(Mode,PRICE_LOW,i,per1,per2, myPeriod )-CHF(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=GBP(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-CHF(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="GBPJPY")
        {
         OPEN=GBP(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-JPY(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=GBP(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-JPY(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=GBP(Mode,PRICE_LOW,i,per1,per2, myPeriod )-JPY(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=GBP(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-JPY(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="USDCHF")
        {
         OPEN=USD(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-CHF(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=USD(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-CHF(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=USD(Mode,PRICE_LOW,i,per1,per2, myPeriod )-CHF(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=USD(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-CHF(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="USDJPY")
        {
         OPEN=USD(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-JPY(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=USD(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-JPY(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=USD(Mode,PRICE_LOW,i,per1,per2, myPeriod )-JPY(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=USD(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-JPY(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
        if (Symbol()=="CHFJPY")
        {
         OPEN=CHF(Mode,PRICE_OPEN,i,per1,per2, myPeriod )-JPY(Mode,PRICE_OPEN,i,per1,per2, myPeriod );
         HIGH=CHF(Mode,PRICE_HIGH,i,per1,per2, myPeriod )-JPY(Mode,PRICE_HIGH,i,per1,per2, myPeriod );
         LOW=CHF(Mode,PRICE_LOW,i,per1,per2, myPeriod )-JPY(Mode,PRICE_LOW,i,per1,per2, myPeriod );
         CLOSE=CHF(Mode,PRICE_CLOSE,i,per1,per2, myPeriod )-JPY(Mode,PRICE_CLOSE,i,per1,per2, myPeriod );
        }
       ExtBuffer0[i]=(OPEN+HIGH+LOW+CLOSE)/4;
//       cVal = pVal; 
//      pVal = (OPEN+HIGH+LOW+CLOSE)/4;          
          
        }
       
       

        
                             
cVal = ExtBuffer0[0] ;  
pVal = ExtBuffer0[1] ; 
                              
                              
                          
                                                                                                                      
pCount  = fDirection( cVal , pVal ) ;

CloseColor = fColor( cVal ) ;

PriceDir = fCompass( pCount ) ;


}

//+------------------------------------------------------------------+ 
void DoDelObj( int lPeriod  )  
{

tObjName01 = labelNames +lPeriod +  "STR230" ;
tObjName02 = labelNames +lPeriod +  "STR231" ;
tObjName03 = labelNames +lPeriod +  "STR232" ;
//tObjName04 = labelNames +  "STR200" ;
tObjName05 = labelNames +lPeriod +  "STR235" ;

ObjectDelete(tObjName01);
ObjectDelete(tObjName02);
ObjectDelete(tObjName03);
ObjectDelete(tObjName04);
ObjectDelete(tObjName05);
}

//+------------------------------------------------------------------+ 
void DoShow( int lPeriod , int xInc)  
{

tObjName01 = labelNames +lPeriod +  "STR230" ;
tObjName02 = labelNames +lPeriod +  "STR231" ;
tObjName03 = labelNames +lPeriod +  "STR232" ;
tObjName05 = labelNames +lPeriod +  "STR235" ;


tPeriod  = TimeFrameToString( lPeriod ) ;

   ObjectCreate(tObjName01, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName01, tPeriod, myFontSize, myFont, CloseColor );
   ObjectSet(tObjName01, OBJPROP_CORNER, 0);
   ObjectSet(tObjName01, OBJPROP_XDISTANCE,  xInc+980+price_x_offset); // 760
   ObjectSet(tObjName01, OBJPROP_YDISTANCE, 175+price_y_offset); // 160

int sInc = 0 ;

if(Show_arrow){

sInc = 50 ;
   
   ObjectCreate(tObjName03, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, PriceDir , myArrowSize , "Wingdings" , CloseColor );
   ObjectSet(tObjName03, OBJPROP_CORNER, 0);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, xInc+980+price_x_offset); // 765
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 210+price_y_offset); 
   
} //if(Show_arrow)


if(Show_value){
    
   ObjectCreate(tObjName05, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName05, DoubleToStr(cVal,myDecimals) ,myDigitSize, myFont , CloseColor );
   ObjectSet(tObjName05, OBJPROP_CORNER, 0);
   ObjectSet(tObjName05, OBJPROP_XDISTANCE, xInc+980+price_x_offset); // 765
   ObjectSet(tObjName05, OBJPROP_YDISTANCE, sInc+210+price_y_offset); 
} //if(Show_value)



}

//+------------------------------------------------------------------+ 

void DoHead( string dHead  )  
{

tObjName04 = labelNames +  "STR200" ;

   ObjectCreate(tObjName04, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName04, dHead, myFontSize, myFont, myIndColor );
   ObjectSet(tObjName04, OBJPROP_CORNER, 0);
   ObjectSet(tObjName04, OBJPROP_XDISTANCE,  00+price_x_offset); // 760
   ObjectSet(tObjName04, OBJPROP_YDISTANCE, 210+price_y_offset); // 160
}

//+------------------------------------------------------------------+ 


// string next() { totalLabels++; return(totalLabels); }  

//+------------------------------------------------------------------+

 
string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}


//+------------------------------------------------------------------+

  double USD(int Mode, int Price, int i, int per1, int per2, int TF)
  {
   return(
            (iMA("EURUSD",TF,per1,0,Mode,Price,i)-
            iMA("EURUSD",TF,per2,0,Mode,Price,i))*10000
            +
            (iMA("GBPUSD",TF,per1,0,Mode,Price,i)-
            iMA("GBPUSD",TF,per2,0,Mode,Price,i))*10000
            +
            (iMA("USDCHF",TF,per2,0,Mode,Price,i)-
            iMA("USDCHF",TF,per1,0,Mode,Price,i))*10000
            +
            (iMA("USDJPY",TF,per2,0,Mode,Price,i)-
            iMA("USDJPY",TF,per1,0,Mode,Price,i))*100
          );
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  double EUR(int Mode, int Price, int i, int per1, int per2, int TF)
  {
   return(
            (iMA("EURUSD",TF,per2,0,Mode,Price,i)-
            iMA("EURUSD",TF,per1,0,Mode,Price,i))*10000
            +
            (iMA("EURGBP",TF,per2,0,Mode,Price,i)-
            iMA("EURGBP",TF,per1,0,Mode,Price,i))*10000
            +
            (iMA("EURCHF",TF,per2,0,Mode,Price,i)-
            iMA("EURCHF",TF,per1,0,Mode,Price,i))*10000
            +
            (iMA("EURJPY",TF,per2,0,Mode,Price,i)-
            iMA("EURJPY",TF,per1,0,Mode,Price,i))*100
          );
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  double GBP(int Mode, int Price, int i, int per1, int per2, int TF)
  {
   return(
            (iMA("GBPUSD",TF,per2,0,Mode,Price,i)-
            iMA("GBPUSD",TF,per1,0,Mode,Price,i))*10000
            +
            (iMA("EURGBP",TF,per1,0,Mode,Price,i)-
            iMA("EURGBP",TF,per2,0,Mode,Price,i))*10000
            +
            (iMA("GBPCHF",TF,per2,0,Mode,Price,i)-
            iMA("GBPCHF",TF,per1,0,Mode,Price,i))*10000
            +
            (iMA("GBPJPY",TF,per2,0,Mode,Price,i)-
            iMA("GBPJPY",TF,per1,0,Mode,Price,i))*100
          );
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  double CHF(int Mode, int Price, int i, int per1, int per2, int TF)
  {
   return(
            (iMA("USDCHF",TF,per1,0,Mode,Price,i)-
            iMA("USDCHF",TF,per2,0,Mode,Price,i))*10000
            +
            (iMA("EURCHF",TF,per1,0,Mode,Price,i)-
            iMA("EURCHF",TF,per2,0,Mode,Price,i))*10000
            +
            (iMA("GBPCHF",TF,per1,0,Mode,Price,i)-
            iMA("GBPCHF",TF,per2,0,Mode,Price,i))*10000
            +
            (iMA("CHFJPY",TF,per2,0,Mode,Price,i)-
            iMA("CHFJPY",TF,per1,0,Mode,Price,i))*100
          );
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  double JPY(int Mode, int Price, int i, int per1, int per2, int TF)
  {
   return(
            (iMA("USDJPY",TF,per1,0,Mode,Price,i)-
            iMA("USDJPY",TF,per2,0,Mode,Price,i))*100
            +
            (iMA("EURJPY",TF,per1,0,Mode,Price,i)-
            iMA("EURJPY",TF,per2,0,Mode,Price,i))*100
            +
            (iMA("GBPJPY",TF,per1,0,Mode,Price,i)-
            iMA("GBPJPY",TF,per2,0,Mode,Price,i))*100
            +
            (iMA("CHFJPY",TF,per1,0,Mode,Price,i)-
            iMA("CHFJPY",TF,per2,0,Mode,Price,i))*100
          );
  }
//+------------------------------------------------------------------+