//+------------------------------------------------------------------+
//|                       tro_100_dots                               |
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFT AND DONATIONS ACCEPTED                                    | 
//|                                                                  |  
//|    http://docs.mql4.com/constants/wingdings                      |                                         |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne"
#property link      "therumpledone@gmail.com"

#property indicator_chart_window 
#property indicator_buffers 2


extern bool TURN_OFF    = false ;

extern bool Show_Comment =  true ; 
 
extern int    myBars  = 100; 
extern double MOVED   = 100.0; 
              

extern int myStyle1  = 2 ;
extern int myStyle2  = 2 ;


extern int myWingDing1  = 115 ;
extern int myWingDing2  = 115 ;


extern color myColor1 = Green ;
extern color myColor2 = Red;
 
//---- buffers

double P1Buffer[];
double P2Buffer[];
 
 

string tHundred0 = "Hundred_0" ;
string tHundred1 = "Hundred_1" ;

int    i, limit, digits, period, digits2, LgWin, ShWin, Trades  ; 
double point, X01, X02 ;

double Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2, Range0, Range1, Range2, AvgRng3 ;
 
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);

//----

SetIndexArrow(0, myWingDing1); 
SetIndexArrow(1, myWingDing2); 



   SetIndexStyle(0, DRAW_ARROW, myStyle1, 1, myColor1 );
   SetIndexStyle(1, DRAW_ARROW, myStyle2, 1, myColor2 );   

   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   

   limit = myBars - 1 ;
   deinit();
   
   return(0);
  } 
//+------------------------------------------------------------------+
int deinit()
{
   
   if(Show_Comment) { Comment("") ; }
   TRO();
   
   return(0);
} 

//+------------------------------------------------------------------+
int start()
{

   if( TURN_OFF ) { deinit(); return(0) ; }
     
LgWin  = 0  ; 
ShWin  = 0  ; 
Trades = 0  ;
 
for(i=limit; i>=0 ; i--)
{
      Open0  = iOpen(NULL,0,i) ; 
      High0  = iHigh(NULL,0,i) ; 
      Low0   = iLow(NULL,0,i) ; 
      Close0 = iClose(NULL,0,i) ; 
       				
      X01 = (High0 - Open0) / point ;  
      X02 = (Open0 - Low0) / point ;  

      if(X01 > MOVED ) { P1Buffer[i] = High0 ; LgWin = LgWin + 1 ; } else { P1Buffer[i] = 0  ; }
   
      if(X02 > MOVED ) { P2Buffer[i] = Low0  ; ShWin = ShWin + 1 ; } else { P2Buffer[i] = 0  ; }
   
      Trades = Trades + 1  ;

} // FOR 
 
if(Show_Comment)
{ 
 
Comment( "\n", 
"Trades    = ", Trades, "\n",        
"Long Win  = ", LgWin, "\n",  
"Short Win = ", ShWin, "\n",  
"X01 = ", DoubleToStr(X01 , digits), "\n",   
"X02 = ", DoubleToStr(X02 , digits), "\n",   

"Open = ", DoubleToStr(Open0 , digits), "\n",  
"High = ", DoubleToStr(High0 , digits), "\n",  
"Low = ", DoubleToStr(Low0 , digits), "\n", 
"") ;
}

 
    
return(0);
}


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
  
