//+------------------------------------------------------------------+
//|              tro_mo_numbers                                      |
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 4
 
extern  bool Show_Help        = false ;
extern color colorHelp        = Orange ; 
 
extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 12 ; 
extern color  myColor      = Blue ;
extern color  myZcolor     = Magenta ;

extern int myStart = 0  ;
extern int myBars  = 100 ;
 
//---- buffers

double     H_Buffer[];
double     L_Buffer[];


string SHORTNAME ;
string totOT1 , totOT2, totOT3 ;

string symbol, tChartPeriod,  tShortName ;    
int    digits, period, digits2  ; 


double open1,close1,open0,close0,high, low, diff0, diff1 ;

		
   double X01,X03, X04  ;
   double X02  ; 

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011,Obj0012,Obj0013,Obj0014,Obj0015,Obj0016,Obj0017;  

string aHelp[20];
double curr[], prev[] ;
int limit, zSize;    
 
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   
 
   SetIndexStyle(0,DRAW_NONE);  
   SetIndexStyle(1,DRAW_NONE); 
   SetIndexStyle(2,DRAW_NONE); 

   SetIndexBuffer(0,H_Buffer);
   SetIndexBuffer(1,curr);
   SetIndexBuffer(2,prev); 

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0); 
   
   
   period = Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;
 
     
   SHORTNAME = "monum" ;
   
   return(0);
  } 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix("monum");     
      
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{ 

   if(Show_Help) { DoHelp () ; } else { deinit() ; }   

   
   limit = myBars ;

   for(int i=0; i<limit; i++)
   {
      curr[i] = MathAbs( Close[i] - Open[i]  ) ;
   }   
   
   
   for( i=myStart; i<limit; i++)
   {   
      H_Buffer[i] = 0 ;
      for(int j=i+1; j<limit; j++)
      {  
         if( curr[i] > curr[j] ) { H_Buffer[i] = H_Buffer[i] + 1 ; }
         else { break ; }
      } // for j
   
      if( H_Buffer[i] > 0 ) 
      { 
         DoPlot( i , H_Buffer[i]) ; 
         if(curr[i+1] != 0)
         {
            zSize = MathFloor(curr[i] / curr[i+1])  ;
            if(zSize > 1) { DoPlotZ( i , zSize) ; }
         }
      }
      
      
       
   } // for i
   
   return(0);
}

//+------------------------------------------------------------------+ 

void DoPlot( int p , double pNum )
{

  string sSHORTNAME = SHORTNAME + p ;
  string sNum    = DoubleToStr(pNum , 0) ;
  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],Low[p]); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, myColor );   

      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],Low[p]);
      }
 
}

//+------------------------------------------------------------------+ 

void DoPlotZ( int p , double pNum )
{

  string sSHORTNAME = SHORTNAME+ "Z" + p ;
  string sNum    = DoubleToStr(pNum , 0) ;
  
  double zSpot ;
  
  zSpot =  High[p] + 2* myFontSize * Point  ;
  
  if (ObjectFind(sSHORTNAME) != 0)
      {
          ObjectCreate(sSHORTNAME,OBJ_TEXT,0,Time[p],zSpot); 
          ObjectSetText(sSHORTNAME, sNum , myFontSize, myFont, myZcolor );   
          ObjectSet(sSHORTNAME,OBJPROP_BACK,false) ;
      } 
      else
      {
         ObjectMove(sSHORTNAME,0,Time[p],zSpot);
      }
 
}

//+------------------------------------------------------------------+
 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
  
//+------------------------------------------------------------------+  

void DoHelp()
{



aHelp[0] = "TRO_MO_NUMBERS" ;
aHelp[1] = " " ;
aHelp[2] = "If a candle closes after a momentum move then it will be larger" ;
aHelp[3] = "than the prev. candle & it may be larger than a consecutive" ;
aHelp[4] = "number of candles in the past." ;
aHelp[5] = " " ;
aHelp[6] = "The smaller this number is the stronger the move to come. " ;
aHelp[7] = "  " ;
aHelp[8] = "The larger this number is the weaker the move to come. " ;  
aHelp[9]  = " " ;
aHelp[10] = "The larger the numbers the fewer the pips left in that " ;
aHelp[11] = "direction. " ;
aHelp[12] = " " ;
aHelp[13] = "The candles are labeled based on the number of consecutive " ;
aHelp[14] = "candles smaller than the candle to close. " ;
aHelp[15] = " " ;
aHelp[16] = "If this number is zero then price retains the strength of the" ;
aHelp[17] = "last labeled candle.  " ;
aHelp[18] = " " ;
aHelp[19] = " " ;

ArrayResize(aHelp,20);

for( int h = 0 ; h < 20 ; h++ )
{
   drawComment(SHORTNAME+"aHelp"+h,aHelp[h] , 10, 120 + 20*h , colorHelp  ) ;
} 

}

//+------------------------------------------------------------------+  
 
void drawComment(string tLabel,string name, int xPos, int yPos ,color Color  )
{

ObjectCreate(tLabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(tLabel, OBJPROP_CORNER, 0 );
ObjectSet(tLabel,OBJPROP_XDISTANCE,xPos);
ObjectSet(tLabel,OBJPROP_YDISTANCE,yPos);
ObjectSetText(tLabel,name,12,"Courier New",Color); 
} 

//+------------------------------------------------------------------+  




